(set-info :smt-lib-version 2.6)
(set-logic AUFNIRA)
(set-info :source |
These benchmarks come from the verification of C programs using Why
from the aviation industry.
|)
(set-info :category "industrial")
(declare-sort c_Boolean 0)
(declare-fun c_Boolean_true () c_Boolean)
(declare-fun c_Boolean_false () c_Boolean)
(assert (forall ((?bcd c_Boolean)) (or (= ?bcd c_Boolean_true) (= ?bcd c_Boolean_false))))
(assert (not (= c_Boolean_true c_Boolean_false)))
(declare-sort Unit 0)
(declare-fun div_int (Int Int) Int)
(declare-fun modulo (Int Int) Int)
(declare-sort c_unsorted 0)
(declare-sort c_sorted 0)
(declare-sort c_type 0)
(declare-fun c_int () c_type)
(declare-fun c_bool () c_type)
(declare-fun c_real () c_type)
(declare-fun c_unit () c_type)
(declare-fun c_sort (c_type c_unsorted) c_sorted)
(declare-fun int2u (Int) c_unsorted)
(declare-fun bool2u (c_Boolean) c_unsorted)
(declare-fun real2u (Real) c_unsorted)
(declare-fun unit2u (Unit) c_unsorted)
(declare-fun s2int (c_sorted) Int)
(declare-fun s2bool (c_sorted) c_Boolean)
(declare-fun s2real (c_sorted) Real)
(declare-fun s2unit (c_sorted) Unit)
(assert (forall ((?xu0_1 Int)) (= (s2int (c_sort c_int (int2u ?xu0_1))) ?xu0_1)))
(assert (forall ((?xu0_2 c_Boolean)) (= (s2bool (c_sort c_bool (bool2u ?xu0_2))) ?xu0_2)))
(assert (forall ((?xu0_3 Real)) (= (s2real (c_sort c_real (real2u ?xu0_3))) ?xu0_3)))
(assert (forall ((?xu0_4 Unit)) (= (s2unit (c_sort c_unit (unit2u ?xu0_4))) ?xu0_4)))
(assert (forall ((?xu0_5 c_unsorted)) (= (int2u (s2int (c_sort c_int ?xu0_5))) ?xu0_5)))
(assert (forall ((?xu0_6 c_unsorted)) (= (bool2u (s2bool (c_sort c_bool ?xu0_6))) ?xu0_6)))
(assert (forall ((?xu0_7 c_unsorted)) (= (real2u (s2real (c_sort c_real ?xu0_7))) ?xu0_7)))
(assert (forall ((?xu0_8 c_unsorted)) (= (unit2u (s2unit (c_sort c_unit ?xu0_8))) ?xu0_8)))
(declare-fun eq_unit (Unit Unit) Bool)
(declare-fun neq_unit (Unit Unit) Bool)
(declare-fun eq_bool (c_Boolean c_Boolean) Bool)
(declare-fun neq_bool (c_Boolean c_Boolean) Bool)
(declare-fun eq_int (Int Int) Bool)
(declare-fun neq_int (Int Int) Bool)
(declare-fun zwf_zero (Int Int) Bool)
(assert (forall ((?au0_9 Int)) (forall ((?bu0_10 Int)) (let ((?v_0 (and (<= 0 ?bu0_10) (< ?au0_9 ?bu0_10)))) (= ?v_0 ?v_0)))))
(declare-fun bool_and (c_Boolean c_Boolean) c_Boolean)
(declare-fun bool_or (c_Boolean c_Boolean) c_Boolean)
(declare-fun bool_xor (c_Boolean c_Boolean) c_Boolean)
(declare-fun bool_not (c_Boolean) c_Boolean)
(assert (forall ((?au33_11 c_Boolean)) (forall ((?bu32_12 c_Boolean)) (= (= (bool_and ?au33_11 ?bu32_12) c_Boolean_true) (and (= ?au33_11 c_Boolean_true) (= ?bu32_12 c_Boolean_true))))))
(assert (forall ((?au35_13 c_Boolean)) (forall ((?bu34_14 c_Boolean)) (= (= (bool_or ?au35_13 ?bu34_14) c_Boolean_true) (or (= ?au35_13 c_Boolean_true) (= ?bu34_14 c_Boolean_true))))))
(assert (forall ((?au37_15 c_Boolean)) (forall ((?bu36_16 c_Boolean)) (= (= (bool_xor ?au37_15 ?bu36_16) c_Boolean_true) (not (= ?au37_15 ?bu36_16))))))
(assert (forall ((?au38_17 c_Boolean)) (= (= (bool_not ?au38_17) c_Boolean_true) (= ?au38_17 c_Boolean_false))))
(declare-fun smtlib__ite (c_Boolean c_sorted c_sorted) c_unsorted)
(assert (forall ((?t1u0_18 c_type)) (forall ((?xu40_19 c_unsorted)) (forall ((?yu39_20 c_unsorted)) (let ((?v_0 (c_sort ?t1u0_18 ?xu40_19))) (= (c_sort ?t1u0_18 (smtlib__ite c_Boolean_true ?v_0 (c_sort ?t1u0_18 ?yu39_20))) ?v_0))))))
(assert (forall ((?t1u0_21 c_type)) (forall ((?xu42_22 c_unsorted)) (forall ((?yu41_23 c_unsorted)) (let ((?v_0 (c_sort ?t1u0_21 ?yu41_23))) (= (c_sort ?t1u0_21 (smtlib__ite c_Boolean_false (c_sort ?t1u0_21 ?xu42_22) ?v_0)) ?v_0))))))
(declare-fun lt_int_bool (Int Int) c_Boolean)
(declare-fun le_int_bool (Int Int) c_Boolean)
(declare-fun gt_int_bool (Int Int) c_Boolean)
(declare-fun ge_int_bool (Int Int) c_Boolean)
(declare-fun eq_int_bool (Int Int) c_Boolean)
(declare-fun neq_int_bool (Int Int) c_Boolean)
(assert (forall ((?xu45_24 Int)) (forall ((?yu44_25 Int)) (= (= (lt_int_bool ?xu45_24 ?yu44_25) c_Boolean_true) (< ?xu45_24 ?yu44_25)))))
(assert (forall ((?xu47_26 Int)) (forall ((?yu46_27 Int)) (= (= (le_int_bool ?xu47_26 ?yu46_27) c_Boolean_true) (<= ?xu47_26 ?yu46_27)))))
(assert (forall ((?xu49_28 Int)) (forall ((?yu48_29 Int)) (= (= (gt_int_bool ?xu49_28 ?yu48_29) c_Boolean_true) (> ?xu49_28 ?yu48_29)))))
(assert (forall ((?xu51_30 Int)) (forall ((?yu50_31 Int)) (= (= (ge_int_bool ?xu51_30 ?yu50_31) c_Boolean_true) (>= ?xu51_30 ?yu50_31)))))
(assert (forall ((?xu53_32 Int)) (forall ((?yu52_33 Int)) (= (= (eq_int_bool ?xu53_32 ?yu52_33) c_Boolean_true) (= ?xu53_32 ?yu52_33)))))
(assert (forall ((?xu55_34 Int)) (forall ((?yu54_35 Int)) (= (= (neq_int_bool ?xu55_34 ?yu54_35) c_Boolean_true) (not (= ?xu55_34 ?yu54_35))))))
(declare-fun abs_int (Int) Int)
(assert (forall ((?xu56_36 Int)) (=> (>= ?xu56_36 0) (= (abs_int ?xu56_36) ?xu56_36))))
(assert (forall ((?xu57_37 Int)) (=> (<= ?xu57_37 0) (= (abs_int ?xu57_37) (- ?xu57_37)))))
(declare-fun int_max (Int Int) Int)
(declare-fun int_min (Int Int) Int)
(assert (forall ((?xu59_38 Int)) (forall ((?yu58_39 Int)) (let ((?v_0 (int_max ?xu59_38 ?yu58_39))) (and (>= ?v_0 ?xu59_38) (>= ?v_0 ?yu58_39))))))
(assert (forall ((?xu61_40 Int)) (forall ((?yu60_41 Int)) (let ((?v_0 (int_max ?xu61_40 ?yu60_41))) (or (= ?v_0 ?xu61_40) (= ?v_0 ?yu60_41))))))
(assert (forall ((?xu63_42 Int)) (forall ((?yu62_43 Int)) (let ((?v_0 (int_min ?xu63_42 ?yu62_43))) (and (<= ?v_0 ?xu63_42) (<= ?v_0 ?yu62_43))))))
(assert (forall ((?xu65_44 Int)) (forall ((?yu64_45 Int)) (let ((?v_0 (int_min ?xu65_44 ?yu64_45))) (or (= ?v_0 ?xu65_44) (= ?v_0 ?yu64_45))))))
(declare-fun lt_real (Real Real) Bool)
(declare-fun le_real (Real Real) Bool)
(declare-fun gt_real (Real Real) Bool)
(declare-fun ge_real (Real Real) Bool)
(declare-fun eq_real (Real Real) Bool)
(declare-fun neq_real (Real Real) Bool)
(declare-fun add_real (Real Real) Real)
(declare-fun sub_real (Real Real) Real)
(declare-fun mul_real (Real Real) Real)
(declare-fun div_real (Real Real) Real)
(declare-fun neg_real (Real) Real)
(declare-fun real_of_int (Int) Real)
(declare-fun int_of_real (Real) Int)
(declare-fun lt_real_bool (Real Real) c_Boolean)
(declare-fun le_real_bool (Real Real) c_Boolean)
(declare-fun gt_real_bool (Real Real) c_Boolean)
(declare-fun ge_real_bool (Real Real) c_Boolean)
(declare-fun eq_real_bool (Real Real) c_Boolean)
(declare-fun neq_real_bool (Real Real) c_Boolean)
(assert (forall ((?xu82_46 Real)) (forall ((?yu81_47 Real)) (= (= (lt_real_bool ?xu82_46 ?yu81_47) c_Boolean_true) (< ?xu82_46 ?yu81_47)))))
(assert (forall ((?xu84_48 Real)) (forall ((?yu83_49 Real)) (= (= (le_real_bool ?xu84_48 ?yu83_49) c_Boolean_true) (<= ?xu84_48 ?yu83_49)))))
(assert (forall ((?xu86_50 Real)) (forall ((?yu85_51 Real)) (= (= (gt_real_bool ?xu86_50 ?yu85_51) c_Boolean_true) (> ?xu86_50 ?yu85_51)))))
(assert (forall ((?xu88_52 Real)) (forall ((?yu87_53 Real)) (= (= (ge_real_bool ?xu88_52 ?yu87_53) c_Boolean_true) (>= ?xu88_52 ?yu87_53)))))
(assert (forall ((?xu90_54 Real)) (forall ((?yu89_55 Real)) (= (= (eq_real_bool ?xu90_54 ?yu89_55) c_Boolean_true) (= ?xu90_54 ?yu89_55)))))
(assert (forall ((?xu92_56 Real)) (forall ((?yu91_57 Real)) (= (= (neq_real_bool ?xu92_56 ?yu91_57) c_Boolean_true) (not (= ?xu92_56 ?yu91_57))))))
(declare-fun real_max (Real Real) Real)
(declare-fun real_min (Real Real) Real)
(assert (forall ((?xu94_58 Real)) (forall ((?yu93_59 Real)) (let ((?v_0 (real_max ?xu94_58 ?yu93_59))) (and (>= ?v_0 ?xu94_58) (>= ?v_0 ?yu93_59))))))
(assert (forall ((?xu96_60 Real)) (forall ((?yu95_61 Real)) (let ((?v_0 (real_max ?xu96_60 ?yu95_61))) (or (= ?v_0 ?xu96_60) (= ?v_0 ?yu95_61))))))
(assert (forall ((?xu98_62 Real)) (forall ((?yu97_63 Real)) (let ((?v_0 (real_min ?xu98_62 ?yu97_63))) (and (<= ?v_0 ?xu98_62) (<= ?v_0 ?yu97_63))))))
(assert (forall ((?xu100_64 Real)) (forall ((?yu99_65 Real)) (let ((?v_0 (real_min ?xu100_64 ?yu99_65))) (or (= ?v_0 ?xu100_64) (= ?v_0 ?yu99_65))))))
(declare-fun sqrt_real (Real) Real)
(declare-fun pow_real (Real Real) Real)
(declare-fun abs_real (Real) Real)
(assert (forall ((?xu102_66 Real)) (=> (>= ?xu102_66 0.0) (= (abs_real ?xu102_66) ?xu102_66))))
(assert (forall ((?xu103_67 Real)) (=> (<= ?xu103_67 0.0) (= (abs_real ?xu103_67) (- ?xu103_67)))))
(declare-fun exp (Real) Real)
(declare-fun log (Real) Real)
(declare-fun log10 (Real) Real)
(assert (forall ((?xu104_68 Real)) (= (log (exp ?xu104_68)) ?xu104_68)))
(declare-fun cos (Real) Real)
(declare-fun sin (Real) Real)
(declare-fun tan (Real) Real)
(declare-fun cosh (Real) Real)
(declare-fun sinh (Real) Real)
(declare-fun tanh (Real) Real)
(declare-fun acos (Real) Real)
(declare-fun asin (Real) Real)
(declare-fun atan (Real) Real)
(declare-fun atan2 (Real Real) Real)
(declare-fun hypot (Real Real) Real)
(declare-fun alloc_table (c_type) c_type)
(declare-fun pointer (c_type) c_type)
(declare-fun block (c_type) c_type)
(declare-fun base_block (c_sorted) c_unsorted)
(declare-fun pointer_address (c_sorted) c_unsorted)
(declare-fun absolute_address (Int) c_unsorted)
(declare-fun address (c_sorted) Int)
(declare-fun offset_max (c_sorted c_sorted) Int)
(declare-fun offset_min (c_sorted c_sorted) Int)
(declare-fun valid (c_sorted c_sorted) Bool)
(assert (forall ((?t1u0_69 c_type)) (forall ((?au0_70 c_unsorted)) (forall ((?pu0_71 c_unsorted)) (let ((?v_0 (c_sort (alloc_table ?t1u0_69) ?au0_70)) (?v_1 (c_sort (pointer ?t1u0_69) ?pu0_71))) (= (valid ?v_0 ?v_1) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) 0))))))))
(declare-fun same_block (c_sorted c_sorted) Bool)
(assert (forall ((?t1u0_72 c_type)) (forall ((?pu0_73 c_unsorted)) (forall ((?qu0_74 c_unsorted)) (let ((?v_0 (pointer ?t1u0_72))) (let ((?v_1 (c_sort ?v_0 ?pu0_73)) (?v_3 (c_sort ?v_0 ?qu0_74)) (?v_2 (block ?t1u0_72))) (= (same_block ?v_1 ?v_3) (= (c_sort ?v_2 (base_block ?v_1)) (c_sort ?v_2 (base_block ?v_3))))))))))
(declare-fun sub_pointer (c_sorted c_sorted) Int)
(declare-fun shift (c_sorted Int) c_unsorted)
(declare-fun null () c_unsorted)
(assert (forall ((?t1u0_75 c_type)) (forall ((?pu111_76 c_unsorted)) (forall ((?qu110_77 c_unsorted)) (let ((?v_0 (pointer ?t1u0_75))) (let ((?v_1 (c_sort ?v_0 ?pu111_76)) (?v_2 (c_sort ?v_0 ?qu110_77))) (= (= ?v_1 ?v_2) (= (address ?v_1) (address ?v_2)))))))))
(assert (forall ((?t1u0_78 c_type)) (= (address (c_sort (pointer ?t1u0_78) null)) 0)))
(assert (forall ((?t1u0_79 c_type)) (forall ((?pu112_80 c_unsorted)) (<= 0 (address (c_sort (pointer ?t1u0_79) ?pu112_80))))))
(assert (forall ((?t1u0_81 c_type)) (forall ((?pu115_82 c_unsorted)) (forall ((?iu114_83 Int)) (forall ((?ju113_84 Int)) (let ((?v_0 (pointer ?t1u0_81))) (let ((?v_1 (c_sort ?v_0 ?pu115_82))) (= (< (address (c_sort ?v_0 (shift ?v_1 ?iu114_83))) (address (c_sort ?v_0 (shift ?v_1 ?ju113_84)))) (< ?iu114_83 ?ju113_84)))))))))
(assert (forall ((?t1u0_85 c_type)) (forall ((?pu118_86 c_unsorted)) (forall ((?iu117_87 Int)) (forall ((?ju116_88 Int)) (let ((?v_0 (pointer ?t1u0_85))) (let ((?v_1 (c_sort ?v_0 ?pu118_86))) (= (<= (address (c_sort ?v_0 (shift ?v_1 ?iu117_87))) (address (c_sort ?v_0 (shift ?v_1 ?ju116_88)))) (<= ?iu117_87 ?ju116_88)))))))))
(assert (forall ((?t1u0_89 c_type)) (forall ((?pu119_90 c_unsorted)) (let ((?v_0 (pointer ?t1u0_89))) (let ((?v_1 (c_sort ?v_0 ?pu119_90))) (= (c_sort ?v_0 (shift ?v_1 0)) ?v_1))))))
(assert (forall ((?t1u0_91 c_type)) (forall ((?pu122_92 c_unsorted)) (forall ((?iu121_93 Int)) (forall ((?ju120_94 Int)) (let ((?v_0 (pointer ?t1u0_91))) (let ((?v_1 (c_sort ?v_0 ?pu122_92))) (= (c_sort ?v_0 (shift (c_sort ?v_0 (shift ?v_1 ?iu121_93)) ?ju120_94)) (c_sort ?v_0 (shift ?v_1 (+ ?iu121_93 ?ju120_94)))))))))))
(assert (forall ((?t1u0_95 c_type)) (forall ((?au125_96 c_unsorted)) (forall ((?pu124_97 c_unsorted)) (forall ((?iu123_98 Int)) (let ((?v_1 (c_sort (alloc_table ?t1u0_95) ?au125_96)) (?v_0 (pointer ?t1u0_95))) (let ((?v_2 (c_sort ?v_0 ?pu124_97))) (= (offset_max ?v_1 (c_sort ?v_0 (shift ?v_2 ?iu123_98))) (- (offset_max ?v_1 ?v_2) ?iu123_98)))))))))
(assert (forall ((?t1u0_99 c_type)) (forall ((?au128_100 c_unsorted)) (forall ((?pu127_101 c_unsorted)) (forall ((?iu126_102 Int)) (let ((?v_1 (c_sort (alloc_table ?t1u0_99) ?au128_100)) (?v_0 (pointer ?t1u0_99))) (let ((?v_2 (c_sort ?v_0 ?pu127_101))) (= (offset_min ?v_1 (c_sort ?v_0 (shift ?v_2 ?iu126_102))) (- (offset_min ?v_1 ?v_2) ?iu126_102)))))))))
(assert (forall ((?t1u0_103 c_type)) (forall ((?pu131_104 c_unsorted)) (forall ((?iu130_105 Int)) (forall ((?ju129_106 Int)) (let ((?v_0 (pointer ?t1u0_103))) (let ((?v_1 (c_sort ?v_0 ?pu131_104))) (=> (not (= ?iu130_105 ?ju129_106)) (not (= (c_sort ?v_0 (shift ?v_1 ?iu130_105)) (c_sort ?v_0 (shift ?v_1 ?ju129_106))))))))))))
(assert (forall ((?t1u0_107 c_type)) (forall ((?au132_108 c_unsorted)) (not (valid (c_sort (alloc_table ?t1u0_107) ?au132_108) (c_sort (pointer ?t1u0_107) null))))))
(assert (forall ((?t1u0_109 c_type)) (forall ((?au133_110 c_unsorted)) (let ((?v_0 (c_sort (alloc_table ?t1u0_109) ?au133_110)) (?v_1 (c_sort (pointer ?t1u0_109) null))) (and (>= (offset_min ?v_0 ?v_1) 0) (<= (offset_max ?v_0 ?v_1) (- 2)))))))
(declare-fun eq_pointer_bool (c_sorted c_sorted) c_Boolean)
(declare-fun neq_pointer_bool (c_sorted c_sorted) c_Boolean)
(assert (forall ((?t1u0_111 c_type)) (forall ((?p1u143_112 c_unsorted)) (forall ((?p2u142_113 c_unsorted)) (let ((?v_0 (pointer ?t1u0_111))) (let ((?v_1 (c_sort ?v_0 ?p1u143_112)) (?v_2 (c_sort ?v_0 ?p2u142_113))) (= (= (eq_pointer_bool ?v_1 ?v_2) c_Boolean_true) (= ?v_1 ?v_2))))))))
(assert (forall ((?t1u0_114 c_type)) (forall ((?p1u145_115 c_unsorted)) (forall ((?p2u144_116 c_unsorted)) (let ((?v_0 (pointer ?t1u0_114))) (let ((?v_1 (c_sort ?v_0 ?p1u145_115)) (?v_2 (c_sort ?v_0 ?p2u144_116))) (= (= (neq_pointer_bool ?v_1 ?v_2) c_Boolean_true) (not (= ?v_1 ?v_2)))))))))
(assert (forall ((?t1u0_117 c_type)) (forall ((?pu148_118 c_unsorted)) (forall ((?qu147_119 c_unsorted)) (forall ((?iu146_120 Int)) (let ((?v_0 (pointer ?t1u0_117))) (let ((?v_1 (c_sort ?v_0 ?pu148_118)) (?v_2 (c_sort ?v_0 ?qu147_119))) (=> (same_block ?v_1 ?v_2) (same_block ?v_1 (c_sort ?v_0 (shift ?v_2 ?iu146_120)))))))))))
(assert (forall ((?t1u0_121 c_type)) (forall ((?pu151_122 c_unsorted)) (forall ((?qu150_123 c_unsorted)) (forall ((?iu149_124 Int)) (let ((?v_0 (pointer ?t1u0_121))) (let ((?v_1 (c_sort ?v_0 ?qu150_123)) (?v_2 (c_sort ?v_0 ?pu151_122))) (=> (same_block ?v_1 ?v_2) (same_block (c_sort ?v_0 (shift ?v_1 ?iu149_124)) ?v_2)))))))))
(assert (forall ((?t1u0_125 c_type)) (forall ((?pu153_126 c_unsorted)) (forall ((?qu152_127 c_unsorted)) (let ((?v_0 (pointer ?t1u0_125))) (let ((?v_1 (c_sort ?v_0 ?pu153_126)) (?v_2 (c_sort ?v_0 ?qu152_127))) (=> (same_block ?v_1 ?v_2) (= ?v_1 (c_sort ?v_0 (shift ?v_2 (sub_pointer ?v_1 ?v_2)))))))))))
(assert (forall ((?t1u0_128 c_type)) (forall ((?pu154_129 c_unsorted)) (let ((?v_0 (c_sort (pointer ?t1u0_128) ?pu154_129))) (= (sub_pointer ?v_0 ?v_0) 0)))))
(assert (forall ((?t1u0_130 c_type)) (forall ((?pu156_131 c_unsorted)) (forall ((?qu155_132 c_unsorted)) (let ((?v_0 (pointer ?t1u0_130))) (let ((?v_1 (c_sort ?v_0 ?pu156_131)) (?v_2 (c_sort ?v_0 ?qu155_132))) (=> (same_block ?v_1 ?v_2) (=> (= (sub_pointer ?v_1 ?v_2) 0) (= ?v_1 ?v_2)))))))))
(assert (forall ((?t1u0_133 c_type)) (forall ((?pu159_134 c_unsorted)) (forall ((?qu158_135 c_unsorted)) (forall ((?iu157_136 Int)) (let ((?v_0 (pointer ?t1u0_133))) (let ((?v_1 (c_sort ?v_0 ?pu159_134)) (?v_2 (c_sort ?v_0 ?qu158_135))) (= (sub_pointer (c_sort ?v_0 (shift ?v_1 ?iu157_136)) ?v_2) (+ (sub_pointer ?v_1 ?v_2) ?iu157_136)))))))))
(assert (forall ((?t1u0_137 c_type)) (forall ((?pu162_138 c_unsorted)) (forall ((?qu161_139 c_unsorted)) (forall ((?iu160_140 Int)) (let ((?v_0 (pointer ?t1u0_137))) (let ((?v_1 (c_sort ?v_0 ?pu162_138)) (?v_2 (c_sort ?v_0 ?qu161_139))) (= (sub_pointer ?v_1 (c_sort ?v_0 (shift ?v_2 ?iu160_140))) (- (sub_pointer ?v_1 ?v_2) ?iu160_140)))))))))
(declare-fun memory (c_type c_type) c_type)
(declare-fun smtlib__select (c_sorted c_sorted) c_unsorted)
(declare-fun smtlib__store (c_sorted c_sorted c_sorted) c_unsorted)
(assert (forall ((?t2u0_141 c_type)) (forall ((?t1u0_142 c_type)) (forall ((?mu166_143 c_unsorted)) (forall ((?p1u165_144 c_unsorted)) (forall ((?p2u164_145 c_unsorted)) (forall ((?au163_146 c_unsorted)) (let ((?v_0 (pointer ?t1u0_142))) (let ((?v_2 (c_sort ?v_0 ?p1u165_144)) (?v_3 (c_sort ?v_0 ?p2u164_145)) (?v_1 (memory ?t1u0_142 ?t2u0_141)) (?v_4 (c_sort ?t2u0_141 ?au163_146))) (=> (= ?v_2 ?v_3) (= (c_sort ?t2u0_141 (smtlib__select (c_sort ?v_1 (smtlib__store (c_sort ?v_1 ?mu166_143) ?v_2 ?v_4)) ?v_3)) ?v_4)))))))))))
(assert (forall ((?t2u0_147 c_type)) (forall ((?t1u0_148 c_type)) (forall ((?mu170_149 c_unsorted)) (forall ((?p1u169_150 c_unsorted)) (forall ((?p2u168_151 c_unsorted)) (forall ((?au167_152 c_unsorted)) (let ((?v_0 (pointer ?t1u0_148))) (let ((?v_2 (c_sort ?v_0 ?p1u169_150)) (?v_3 (c_sort ?v_0 ?p2u168_151)) (?v_1 (memory ?t1u0_148 ?t2u0_147))) (let ((?v_4 (c_sort ?v_1 ?mu170_149))) (=> (not (= ?v_2 ?v_3)) (= (c_sort ?t2u0_147 (smtlib__select (c_sort ?v_1 (smtlib__store ?v_4 ?v_2 (c_sort ?t2u0_147 ?au167_152))) ?v_3)) (c_sort ?t2u0_147 (smtlib__select ?v_4 ?v_3))))))))))))))
(declare-fun pset (c_type) c_type)
(declare-fun pset_empty () c_unsorted)
(declare-fun pset_singleton (c_sorted) c_unsorted)
(declare-fun pset_deref (c_sorted c_sorted) c_unsorted)
(declare-fun pset_union (c_sorted c_sorted) c_unsorted)
(declare-fun pset_all (c_sorted) c_unsorted)
(declare-fun pset_range (c_sorted Int Int) c_unsorted)
(declare-fun pset_range_left (c_sorted Int) c_unsorted)
(declare-fun pset_range_right (c_sorted Int) c_unsorted)
(declare-fun in_pset (c_sorted c_sorted) Bool)
(declare-fun valid_pset (c_sorted c_sorted) Bool)
(declare-fun pset_disjoint (c_sorted c_sorted) Bool)
(assert (forall ((?t1u0_153 c_type)) (forall ((?ps1u0_154 c_unsorted)) (forall ((?ps2u0_155 c_unsorted)) (let ((?v_0 (pset ?t1u0_153))) (= (pset_disjoint (c_sort ?v_0 ?ps1u0_154) (c_sort ?v_0 ?ps2u0_155)) (forall ((?pu261_156 c_unsorted)) (let ((?v_1 (c_sort (pointer ?t1u0_153) ?pu261_156))) (not (and (in_pset ?v_1 (c_sort ?v_0 ?ps1u0_154)) (in_pset ?v_1 (c_sort ?v_0 ?ps2u0_155))))))))))))
(declare-fun pset_included (c_sorted c_sorted) Bool)
(assert (forall ((?t1u0_157 c_type)) (forall ((?ps1u0_158 c_unsorted)) (forall ((?ps2u0_159 c_unsorted)) (let ((?v_0 (pset ?t1u0_157))) (= (pset_included (c_sort ?v_0 ?ps1u0_158) (c_sort ?v_0 ?ps2u0_159)) (forall ((?pu262_160 c_unsorted)) (let ((?v_1 (c_sort (pointer ?t1u0_157) ?pu262_160))) (=> (in_pset ?v_1 (c_sort ?v_0 ?ps1u0_158)) (in_pset ?v_1 (c_sort ?v_0 ?ps2u0_159)))))))))))
(assert (forall ((?t1u0_161 c_type)) (forall ((?psu263_162 c_unsorted)) (let ((?v_0 (c_sort (pset ?t1u0_161) ?psu263_162))) (pset_included ?v_0 ?v_0)))))
(assert (forall ((?t1u0_163 c_type)) (forall ((?psu268_164 c_unsorted)) (forall ((?au267_165 Int)) (forall ((?bu266_166 Int)) (forall ((?cu265_167 Int)) (forall ((?du264_168 Int)) (let ((?v_0 (pset ?t1u0_163))) (let ((?v_1 (c_sort ?v_0 ?psu268_164))) (=> (and (<= ?cu265_167 ?au267_165) (<= ?bu266_166 ?du264_168)) (pset_included (c_sort ?v_0 (pset_range ?v_1 ?au267_165 ?bu266_166)) (c_sort ?v_0 (pset_range ?v_1 ?cu265_167 ?du264_168)))))))))))))
(assert (forall ((?t1u0_169 c_type)) (forall ((?psu273_170 c_unsorted)) (forall ((?au272_171 Int)) (forall ((?bu271_172 Int)) (forall ((?cu270_173 Int)) (forall ((?du269_174 Int)) (let ((?v_0 (pset ?t1u0_169))) (let ((?v_1 (c_sort ?v_0 ?psu273_170))) (pset_included (c_sort ?v_0 (pset_range ?v_1 ?au272_171 ?bu271_172)) (c_sort ?v_0 (pset_all ?v_1))))))))))))
(assert (forall ((?t1u0_175 c_type)) (forall ((?pu274_176 c_unsorted)) (not (in_pset (c_sort (pointer ?t1u0_175) ?pu274_176) (c_sort (pset ?t1u0_175) pset_empty))))))
(assert (forall ((?t1u0_177 c_type)) (forall ((?pu276_178 c_unsorted)) (forall ((?qu275_179 c_unsorted)) (let ((?v_0 (pointer ?t1u0_177))) (let ((?v_1 (c_sort ?v_0 ?pu276_178)) (?v_2 (c_sort ?v_0 ?qu275_179))) (= (in_pset ?v_1 (c_sort (pset ?t1u0_177) (pset_singleton ?v_2))) (= ?v_1 ?v_2))))))))
(assert (forall ((?t2u0_180 c_type)) (forall ((?t1u0_181 c_type)) (forall ((?pu280_182 c_unsorted)) (forall ((?mu279_183 c_unsorted)) (forall ((?qu278_184 c_unsorted)) (let ((?v_0 (pointer ?t1u0_181))) (= (in_pset (c_sort ?v_0 ?pu280_182) (c_sort (pset ?t1u0_181) (pset_deref (c_sort (memory ?t2u0_180 ?v_0) ?mu279_183) (c_sort (pset ?t2u0_180) ?qu278_184)))) (exists ((?ru277_185 c_unsorted)) (let ((?v_1 (c_sort (pointer ?t2u0_180) ?ru277_185))) (and (in_pset ?v_1 (c_sort (pset ?t2u0_180) ?qu278_184)) (= (c_sort ?v_0 ?pu280_182) (c_sort ?v_0 (smtlib__select (c_sort (memory ?t2u0_180 ?v_0) ?mu279_183) ?v_1))))))))))))))
(assert (forall ((?t1u0_186 c_type)) (forall ((?pu284_187 c_unsorted)) (forall ((?qu283_188 c_unsorted)) (let ((?v_0 (pset ?t1u0_186))) (= (in_pset (c_sort (pointer ?t1u0_186) ?pu284_187) (c_sort ?v_0 (pset_all (c_sort ?v_0 ?qu283_188)))) (exists ((?iu282_189 Int)) (exists ((?ru281_190 c_unsorted)) (let ((?v_1 (pointer ?t1u0_186))) (let ((?v_2 (c_sort ?v_1 ?ru281_190))) (and (in_pset ?v_2 (c_sort ?v_0 ?qu283_188)) (= (c_sort ?v_1 ?pu284_187) (c_sort ?v_1 (shift ?v_2 ?iu282_189))))))))))))))
(assert (forall ((?t1u0_191 c_type)) (forall ((?pu290_192 c_unsorted)) (forall ((?qu289_193 c_unsorted)) (forall ((?au288_194 Int)) (forall ((?bu287_195 Int)) (let ((?v_0 (pset ?t1u0_191))) (= (in_pset (c_sort (pointer ?t1u0_191) ?pu290_192) (c_sort ?v_0 (pset_range (c_sort ?v_0 ?qu289_193) ?au288_194 ?bu287_195))) (exists ((?iu286_196 Int)) (exists ((?ru285_197 c_unsorted)) (let ((?v_1 (pointer ?t1u0_191))) (let ((?v_2 (c_sort ?v_1 ?ru285_197))) (and (<= ?au288_194 ?iu286_196) (and (<= ?iu286_196 ?bu287_195) (and (in_pset ?v_2 (c_sort ?v_0 ?qu289_193)) (= (c_sort ?v_1 ?pu290_192) (c_sort ?v_1 (shift ?v_2 ?iu286_196))))))))))))))))))
(assert (forall ((?t1u0_198 c_type)) (forall ((?pu295_199 c_unsorted)) (forall ((?qu294_200 c_unsorted)) (forall ((?bu293_201 Int)) (let ((?v_0 (pset ?t1u0_198))) (= (in_pset (c_sort (pointer ?t1u0_198) ?pu295_199) (c_sort ?v_0 (pset_range_left (c_sort ?v_0 ?qu294_200) ?bu293_201))) (exists ((?iu292_202 Int)) (exists ((?ru291_203 c_unsorted)) (let ((?v_1 (pointer ?t1u0_198))) (let ((?v_2 (c_sort ?v_1 ?ru291_203))) (and (<= ?iu292_202 ?bu293_201) (and (in_pset ?v_2 (c_sort ?v_0 ?qu294_200)) (= (c_sort ?v_1 ?pu295_199) (c_sort ?v_1 (shift ?v_2 ?iu292_202))))))))))))))))
(assert (forall ((?t1u0_204 c_type)) (forall ((?pu300_205 c_unsorted)) (forall ((?qu299_206 c_unsorted)) (forall ((?au298_207 Int)) (let ((?v_0 (pset ?t1u0_204))) (= (in_pset (c_sort (pointer ?t1u0_204) ?pu300_205) (c_sort ?v_0 (pset_range_right (c_sort ?v_0 ?qu299_206) ?au298_207))) (exists ((?iu297_208 Int)) (exists ((?ru296_209 c_unsorted)) (let ((?v_1 (pointer ?t1u0_204))) (let ((?v_2 (c_sort ?v_1 ?ru296_209))) (and (<= ?au298_207 ?iu297_208) (and (in_pset ?v_2 (c_sort ?v_0 ?qu299_206)) (= (c_sort ?v_1 ?pu300_205) (c_sort ?v_1 (shift ?v_2 ?iu297_208))))))))))))))))
(assert (forall ((?t1u0_210 c_type)) (forall ((?pu303_211 c_unsorted)) (forall ((?s1u302_212 c_unsorted)) (forall ((?s2u301_213 c_unsorted)) (let ((?v_1 (c_sort (pointer ?t1u0_210) ?pu303_211)) (?v_0 (pset ?t1u0_210))) (let ((?v_2 (c_sort ?v_0 ?s1u302_212)) (?v_3 (c_sort ?v_0 ?s2u301_213))) (= (in_pset ?v_1 (c_sort ?v_0 (pset_union ?v_2 ?v_3))) (or (in_pset ?v_1 ?v_2) (in_pset ?v_1 ?v_3))))))))))
(assert (forall ((?t1u0_214 c_type)) (forall ((?au304_215 c_unsorted)) (valid_pset (c_sort (alloc_table ?t1u0_214) ?au304_215) (c_sort (pset ?t1u0_214) pset_empty)))))
(assert (forall ((?t1u0_216 c_type)) (forall ((?au306_217 c_unsorted)) (forall ((?pu305_218 c_unsorted)) (let ((?v_0 (c_sort (alloc_table ?t1u0_216) ?au306_217)) (?v_1 (c_sort (pointer ?t1u0_216) ?pu305_218))) (= (valid_pset ?v_0 (c_sort (pset ?t1u0_216) (pset_singleton ?v_1))) (valid ?v_0 ?v_1)))))))
(assert (forall ((?t2u0_219 c_type)) (forall ((?t1u0_220 c_type)) (forall ((?au311_221 c_unsorted)) (forall ((?mu310_222 c_unsorted)) (forall ((?qu309_223 c_unsorted)) (= (valid_pset (c_sort (alloc_table ?t1u0_220) ?au311_221) (c_sort (pset ?t1u0_220) (pset_deref (c_sort (memory ?t2u0_219 (pointer ?t1u0_220)) ?mu310_222) (c_sort (pset ?t2u0_219) ?qu309_223)))) (forall ((?ru308_224 c_unsorted)) (forall ((?pu307_225 c_unsorted)) (let ((?v_0 (pointer ?t1u0_220)) (?v_1 (c_sort (pointer ?t2u0_219) ?ru308_224))) (let ((?v_2 (c_sort ?v_0 ?pu307_225))) (=> (and (in_pset ?v_1 (c_sort (pset ?t2u0_219) ?qu309_223)) (= ?v_2 (c_sort ?v_0 (smtlib__select (c_sort (memory ?t2u0_219 ?v_0) ?mu310_222) ?v_1)))) (valid (c_sort (alloc_table ?t1u0_220) ?au311_221) ?v_2)))))))))))))
(assert (forall ((?t1u0_226 c_type)) (forall ((?au317_227 c_unsorted)) (forall ((?qu316_228 c_unsorted)) (forall ((?cu315_229 Int)) (forall ((?du314_230 Int)) (let ((?v_0 (pset ?t1u0_226))) (= (valid_pset (c_sort (alloc_table ?t1u0_226) ?au317_227) (c_sort ?v_0 (pset_range (c_sort ?v_0 ?qu316_228) ?cu315_229 ?du314_230))) (forall ((?iu313_231 Int)) (forall ((?ru312_232 c_unsorted)) (let ((?v_1 (pointer ?t1u0_226))) (let ((?v_2 (c_sort ?v_1 ?ru312_232))) (=> (and (in_pset ?v_2 (c_sort ?v_0 ?qu316_228)) (and (<= ?cu315_229 ?iu313_231) (<= ?iu313_231 ?du314_230))) (valid (c_sort (alloc_table ?t1u0_226) ?au317_227) (c_sort ?v_1 (shift ?v_2 ?iu313_231))))))))))))))))
(assert (forall ((?t1u0_233 c_type)) (forall ((?au320_234 c_unsorted)) (forall ((?s1u319_235 c_unsorted)) (forall ((?s2u318_236 c_unsorted)) (let ((?v_1 (c_sort (alloc_table ?t1u0_233) ?au320_234)) (?v_0 (pset ?t1u0_233))) (let ((?v_2 (c_sort ?v_0 ?s1u319_235)) (?v_3 (c_sort ?v_0 ?s2u318_236))) (= (valid_pset ?v_1 (c_sort ?v_0 (pset_union ?v_2 ?v_3))) (and (valid_pset ?v_1 ?v_2) (valid_pset ?v_1 ?v_3))))))))))
(declare-fun not_assigns (c_sorted c_sorted c_sorted c_sorted) Bool)
(assert (forall ((?t2u0_237 c_type)) (forall ((?t1u0_238 c_type)) (forall ((?au0_239 c_unsorted)) (forall ((?m1u0_240 c_unsorted)) (forall ((?m2u0_241 c_unsorted)) (forall ((?lu0_242 c_unsorted)) (let ((?v_0 (memory ?t1u0_238 ?t2u0_237))) (= (not_assigns (c_sort (alloc_table ?t1u0_238) ?au0_239) (c_sort ?v_0 ?m1u0_240) (c_sort ?v_0 ?m2u0_241) (c_sort (pset ?t1u0_238) ?lu0_242)) (forall ((?pu321_243 c_unsorted)) (let ((?v_1 (c_sort (pointer ?t1u0_238) ?pu321_243))) (=> (and (valid (c_sort (alloc_table ?t1u0_238) ?au0_239) ?v_1) (not (in_pset ?v_1 (c_sort (pset ?t1u0_238) ?lu0_242)))) (= (c_sort ?t2u0_237 (smtlib__select (c_sort ?v_0 ?m2u0_241) ?v_1)) (c_sort ?t2u0_237 (smtlib__select (c_sort ?v_0 ?m1u0_240) ?v_1)))))))))))))))
(assert (forall ((?t2u0_244 c_type)) (forall ((?t1u0_245 c_type)) (forall ((?au324_246 c_unsorted)) (forall ((?mu323_247 c_unsorted)) (forall ((?lu322_248 c_unsorted)) (let ((?v_0 (c_sort (memory ?t1u0_245 ?t2u0_244) ?mu323_247))) (not_assigns (c_sort (alloc_table ?t1u0_245) ?au324_246) ?v_0 ?v_0 (c_sort (pset ?t1u0_245) ?lu322_248)))))))))
(assert (forall ((?t2u0_249 c_type)) (forall ((?t1u0_250 c_type)) (forall ((?au329_251 c_unsorted)) (forall ((?m1u328_252 c_unsorted)) (forall ((?m2u327_253 c_unsorted)) (forall ((?m3u326_254 c_unsorted)) (forall ((?lu325_255 c_unsorted)) (let ((?v_1 (c_sort (alloc_table ?t1u0_250) ?au329_251)) (?v_0 (memory ?t1u0_250 ?t2u0_249))) (let ((?v_4 (c_sort ?v_0 ?m1u328_252)) (?v_2 (c_sort ?v_0 ?m2u327_253)) (?v_3 (c_sort (pset ?t1u0_250) ?lu325_255)) (?v_5 (c_sort ?v_0 ?m3u326_254))) (=> (not_assigns ?v_1 ?v_4 ?v_2 ?v_3) (=> (not_assigns ?v_1 ?v_2 ?v_5 ?v_3) (not_assigns ?v_1 ?v_4 ?v_5 ?v_3)))))))))))))
(declare-fun full_separated (c_sorted c_sorted) Bool)
(assert (forall ((?t1u0_256 c_type)) (forall ((?pu332_257 c_unsorted)) (forall ((?qu331_258 c_unsorted)) (forall ((?iu330_259 Int)) (let ((?v_0 (pointer ?t1u0_256))) (let ((?v_1 (c_sort ?v_0 ?pu332_257)) (?v_2 (c_sort ?v_0 ?qu331_258))) (=> (full_separated ?v_1 ?v_2) (full_separated ?v_1 (c_sort ?v_0 (shift ?v_2 ?iu330_259)))))))))))
(assert (forall ((?t1u0_260 c_type)) (forall ((?pu335_261 c_unsorted)) (forall ((?qu334_262 c_unsorted)) (forall ((?iu333_263 Int)) (let ((?v_0 (pointer ?t1u0_260))) (let ((?v_2 (c_sort ?v_0 ?pu335_261)) (?v_1 (c_sort ?v_0 ?qu334_262))) (=> (full_separated ?v_2 ?v_1) (full_separated (c_sort ?v_0 (shift ?v_1 ?iu333_263)) ?v_2)))))))))
(assert (forall ((?t1u0_264 c_type)) (forall ((?pu338_265 c_unsorted)) (forall ((?qu337_266 c_unsorted)) (forall ((?iu336_267 Int)) (let ((?v_0 (pointer ?t1u0_264))) (let ((?v_1 (c_sort ?v_0 ?qu337_266)) (?v_2 (c_sort ?v_0 ?pu338_265))) (=> (full_separated ?v_1 ?v_2) (full_separated (c_sort ?v_0 (shift ?v_1 ?iu336_267)) ?v_2)))))))))
(assert (forall ((?t1u0_268 c_type)) (forall ((?pu341_269 c_unsorted)) (forall ((?qu340_270 c_unsorted)) (forall ((?iu339_271 Int)) (let ((?v_0 (pointer ?t1u0_268))) (let ((?v_2 (c_sort ?v_0 ?qu340_270)) (?v_1 (c_sort ?v_0 ?pu341_269))) (=> (full_separated ?v_2 ?v_1) (full_separated ?v_1 (c_sort ?v_0 (shift ?v_2 ?iu339_271)))))))))))
(declare-fun tag_table (c_type) c_type)
(declare-fun tag_id (c_type) c_type)
(declare-fun int_of_tag (c_sorted) Int)
(declare-fun typeof (c_sorted c_sorted) c_unsorted)
(declare-fun parenttag (c_sorted c_sorted) Bool)
(declare-fun subtag (c_sorted c_sorted) Bool)
(declare-fun subtag_bool (c_sorted c_sorted) c_Boolean)
(assert (forall ((?t1u0_272 c_type)) (forall ((?t1u343_273 c_unsorted)) (forall ((?t2u342_274 c_unsorted)) (let ((?v_0 (tag_id ?t1u0_272))) (let ((?v_1 (c_sort ?v_0 ?t1u343_273)) (?v_2 (c_sort ?v_0 ?t2u342_274))) (= (= (subtag_bool ?v_1 ?v_2) c_Boolean_true) (subtag ?v_1 ?v_2))))))))
(assert (forall ((?t1u0_275 c_type)) (forall ((?tu344_276 c_unsorted)) (let ((?v_0 (c_sort (tag_id ?t1u0_275) ?tu344_276))) (subtag ?v_0 ?v_0)))))
(assert (forall ((?t1u0_277 c_type)) (forall ((?t1u347_278 c_unsorted)) (forall ((?t2u346_279 c_unsorted)) (forall ((?t3u345_280 c_unsorted)) (let ((?v_0 (tag_id ?t1u0_277))) (let ((?v_2 (c_sort ?v_0 ?t1u347_278)) (?v_1 (c_sort ?v_0 ?t2u346_279)) (?v_3 (c_sort ?v_0 ?t3u345_280))) (=> (subtag ?v_2 ?v_1) (=> (parenttag ?v_1 ?v_3) (subtag ?v_2 ?v_3))))))))))
(declare-fun instanceof (c_sorted c_sorted c_sorted) Bool)
(assert (forall ((?t1u0_281 c_type)) (forall ((?au0_282 c_unsorted)) (forall ((?pu0_283 c_unsorted)) (forall ((?tu0_284 c_unsorted)) (let ((?v_1 (c_sort (tag_table ?t1u0_281) ?au0_282)) (?v_2 (c_sort (pointer ?t1u0_281) ?pu0_283)) (?v_0 (tag_id ?t1u0_281))) (let ((?v_3 (c_sort ?v_0 ?tu0_284))) (= (instanceof ?v_1 ?v_2 ?v_3) (subtag (c_sort ?v_0 (typeof ?v_1 ?v_2)) ?v_3)))))))))
(declare-fun downcast (c_sorted c_sorted c_sorted) c_unsorted)
(assert (forall ((?t1u0_285 c_type)) (forall ((?au353_286 c_unsorted)) (forall ((?pu352_287 c_unsorted)) (forall ((?su351_288 c_unsorted)) (let ((?v_1 (c_sort (tag_table ?t1u0_285) ?au353_286)) (?v_0 (pointer ?t1u0_285))) (let ((?v_2 (c_sort ?v_0 ?pu352_287)) (?v_3 (c_sort (tag_id ?t1u0_285) ?su351_288))) (=> (instanceof ?v_1 ?v_2 ?v_3) (= (c_sort ?v_0 (downcast ?v_1 ?v_2 ?v_3)) ?v_2)))))))))
(declare-fun bottom_tag () c_unsorted)
(assert (forall ((?t1u0_289 c_type)) (forall ((?tu360_290 c_unsorted)) (let ((?v_0 (tag_id ?t1u0_289))) (subtag (c_sort ?v_0 ?tu360_290) (c_sort ?v_0 bottom_tag))))))
(declare-fun root_tag (c_sorted) Bool)
(assert (forall ((?t1u0_291 c_type)) (forall ((?tu0_292 c_unsorted)) (let ((?v_1 (tag_id ?t1u0_291))) (let ((?v_0 (c_sort ?v_1 ?tu0_292))) (= (root_tag ?v_0) (parenttag ?v_0 (c_sort ?v_1 bottom_tag))))))))
(assert (forall ((?t1u0_293 c_type)) (forall ((?au363_294 c_unsorted)) (forall ((?bu362_295 c_unsorted)) (forall ((?cu361_296 c_unsorted)) (let ((?v_0 (tag_id ?t1u0_293))) (let ((?v_1 (c_sort ?v_0 ?au363_294)) (?v_2 (c_sort ?v_0 ?bu362_295)) (?v_3 (c_sort ?v_0 ?cu361_296))) (=> (root_tag ?v_1) (=> (root_tag ?v_2) (=> (not (= ?v_1 ?v_2)) (=> (subtag ?v_3 ?v_1) (not (subtag ?v_3 ?v_2)))))))))))))
(declare-fun fully_packed (c_sorted c_sorted c_sorted) Bool)
(assert (forall ((?t1u0_297 c_type)) (forall ((?tagutableu0_298 c_unsorted)) (forall ((?mutableu0_299 c_unsorted)) (forall ((?thisu0_300 c_unsorted)) (let ((?v_3 (c_sort (tag_table ?t1u0_297) ?tagutableu0_298)) (?v_0 (tag_id ?t1u0_297))) (let ((?v_1 (c_sort (memory ?t1u0_297 ?v_0) ?mutableu0_299)) (?v_2 (c_sort (pointer ?t1u0_297) ?thisu0_300))) (= (fully_packed ?v_3 ?v_1 ?v_2) (= (c_sort ?v_0 (smtlib__select ?v_1 ?v_2)) (c_sort ?v_0 (typeof ?v_3 ?v_2)))))))))))
(declare-fun bw_compl (Int) Int)
(declare-fun bw_and (Int Int) Int)
(assert (forall ((?au369_301 Int)) (forall ((?bu368_302 Int)) (=> (not (= (bw_and ?au369_301 ?bu368_302) 0)) (and (not (= ?au369_301 0)) (not (= ?bu368_302 0)))))))
(declare-fun bw_xor (Int Int) Int)
(declare-fun bw_or (Int Int) Int)
(declare-fun lsl (Int Int) Int)
(assert (forall ((?au371_303 Int)) (forall ((?bu370_304 Int)) (=> (and (<= 0 ?au371_303) (<= 0 ?bu370_304)) (<= 0 (lsl ?au371_303 ?bu370_304))))))
(assert (forall ((?a1u374_305 Int)) (forall ((?a2u373_306 Int)) (forall ((?bu372_307 Int)) (=> (and (<= 0 ?a1u374_305) (and (<= ?a1u374_305 ?a2u373_306) (<= 0 ?bu372_307))) (<= (lsl ?a1u374_305 ?bu372_307) (lsl ?a2u373_306 ?bu372_307)))))))
(declare-fun lsr (Int Int) Int)
(assert (forall ((?au376_308 Int)) (forall ((?bu375_309 Int)) (=> (and (<= 0 ?au376_308) (<= 0 ?bu375_309)) (<= 0 (lsr ?au376_308 ?bu375_309))))))
(assert (forall ((?au378_310 Int)) (forall ((?bu377_311 Int)) (=> (and (<= 0 ?au378_310) (<= 0 ?bu377_311)) (<= (lsr ?au378_310 ?bu377_311) ?au378_310)))))
(declare-fun asr (Int Int) Int)
(assert (forall ((?au380_312 Int)) (forall ((?bu379_313 Int)) (=> (and (<= 0 ?au380_312) (<= 0 ?bu379_313)) (<= 0 (asr ?au380_312 ?bu379_313))))))
(assert (forall ((?au382_314 Int)) (forall ((?bu381_315 Int)) (=> (and (<= 0 ?au382_314) (<= 0 ?bu381_315)) (<= (asr ?au382_314 ?bu381_315) ?au382_314)))))
(assert (forall ((?au384_316 Int)) (forall ((?bu383_317 Int)) (=> (and (<= 0 ?au384_316) (<= 0 ?bu383_317)) (= (asr ?au384_316 ?bu383_317) (lsr ?au384_316 ?bu383_317))))))
(assert (forall ((?au386_318 Int)) (forall ((?bu385_319 Int)) (=> (and (<= 0 ?au386_318) (<= 0 ?bu385_319)) (<= (lsl (lsr ?au386_318 ?bu385_319) ?bu385_319) ?au386_318)))))
(assert (forall ((?au388_320 Int)) (forall ((?bu387_321 Int)) (=> (and (<= 0 ?au388_320) (<= 0 ?bu387_321)) (= (lsr (lsl ?au388_320 ?bu387_321) ?bu387_321) ?au388_320)))))
(declare-fun alloc_extends (c_sorted c_sorted) Bool)
(declare-fun alloc_fresh (c_sorted c_sorted Int) Bool)
(assert (forall ((?t1u0_322 c_type)) (forall ((?au0_323 c_unsorted)) (forall ((?pu0_324 c_unsorted)) (forall ((?nu0_325 Int)) (= (alloc_fresh (c_sort (alloc_table ?t1u0_322) ?au0_323) (c_sort (pointer ?t1u0_322) ?pu0_324) ?nu0_325) (forall ((?iu389_326 Int)) (let ((?v_0 (pointer ?t1u0_322))) (=> (and (<= 0 ?iu389_326) (< ?iu389_326 ?nu0_325)) (not (valid (c_sort (alloc_table ?t1u0_322) ?au0_323) (c_sort ?v_0 (shift (c_sort ?v_0 ?pu0_324) ?iu389_326)))))))))))))
(assert (forall ((?t1u0_327 c_type)) (forall ((?a1u392_328 c_unsorted)) (forall ((?a2u391_329 c_unsorted)) (let ((?v_0 (alloc_table ?t1u0_327))) (=> (alloc_extends (c_sort ?v_0 ?a1u392_328) (c_sort ?v_0 ?a2u391_329)) (forall ((?pu390_330 c_unsorted)) (let ((?v_1 (c_sort ?v_0 ?a1u392_328)) (?v_2 (c_sort (pointer ?t1u0_327) ?pu390_330))) (=> (valid ?v_1 ?v_2) (= (offset_min ?v_1 ?v_2) (offset_min (c_sort ?v_0 ?a2u391_329) ?v_2)))))))))))
(assert (forall ((?t1u0_331 c_type)) (forall ((?a1u395_332 c_unsorted)) (forall ((?a2u394_333 c_unsorted)) (let ((?v_0 (alloc_table ?t1u0_331))) (=> (alloc_extends (c_sort ?v_0 ?a1u395_332) (c_sort ?v_0 ?a2u394_333)) (forall ((?pu393_334 c_unsorted)) (let ((?v_1 (c_sort ?v_0 ?a1u395_332)) (?v_2 (c_sort (pointer ?t1u0_331) ?pu393_334))) (=> (valid ?v_1 ?v_2) (= (offset_max ?v_1 ?v_2) (offset_max (c_sort ?v_0 ?a2u394_333) ?v_2)))))))))))
(assert (forall ((?t2u0_335 c_type)) (forall ((?t1u0_336 c_type)) (forall ((?a1u402_337 c_unsorted)) (forall ((?a2u401_338 c_unsorted)) (forall ((?m1u400_339 c_unsorted)) (forall ((?m2u399_340 c_unsorted)) (forall ((?lu398_341 c_unsorted)) (forall ((?pu397_342 c_unsorted)) (forall ((?nu396_343 Int)) (let ((?v_0 (alloc_table ?t1u0_336))) (let ((?v_1 (c_sort ?v_0 ?a1u402_337)) (?v_2 (c_sort ?v_0 ?a2u401_338)) (?v_6 (c_sort (pointer ?t1u0_336) ?pu397_342)) (?v_3 (memory ?t1u0_336 ?t2u0_335))) (let ((?v_7 (c_sort ?v_3 ?m1u400_339)) (?v_8 (c_sort ?v_3 ?m2u399_340)) (?v_5 (pset ?t1u0_336))) (let ((?v_4 (c_sort ?v_5 ?lu398_341))) (=> (and (alloc_extends ?v_1 ?v_2) (and (alloc_fresh ?v_1 ?v_6 ?nu396_343) (and (not_assigns ?v_2 ?v_7 ?v_8 ?v_4) (pset_included ?v_4 (c_sort ?v_5 (pset_all (c_sort ?v_5 (pset_singleton ?v_6)))))))) (not_assigns ?v_1 ?v_7 ?v_8 (c_sort ?v_5 pset_empty)))))))))))))))))
(declare-fun alloc_extends_except (c_sorted c_sorted c_sorted) Bool)
(assert (forall ((?t1u0_344 c_type)) (forall ((?a1u406_345 c_unsorted)) (forall ((?a2u405_346 c_unsorted)) (forall ((?lu404_347 c_unsorted)) (let ((?v_0 (alloc_table ?t1u0_344))) (=> (alloc_extends_except (c_sort ?v_0 ?a1u406_345) (c_sort ?v_0 ?a2u405_346) (c_sort (pset ?t1u0_344) ?lu404_347)) (forall ((?pu403_348 c_unsorted)) (let ((?v_2 (c_sort ?v_0 ?a1u406_345)) (?v_1 (c_sort (pointer ?t1u0_344) ?pu403_348))) (=> (and (valid ?v_2 ?v_1) (not (in_pset ?v_1 (c_sort (pset ?t1u0_344) ?lu404_347)))) (= (offset_min ?v_2 ?v_1) (offset_min (c_sort ?v_0 ?a2u405_346) ?v_1))))))))))))
(assert (forall ((?t1u0_349 c_type)) (forall ((?a1u410_350 c_unsorted)) (forall ((?a2u409_351 c_unsorted)) (forall ((?lu408_352 c_unsorted)) (let ((?v_0 (alloc_table ?t1u0_349))) (=> (alloc_extends_except (c_sort ?v_0 ?a1u410_350) (c_sort ?v_0 ?a2u409_351) (c_sort (pset ?t1u0_349) ?lu408_352)) (forall ((?pu407_353 c_unsorted)) (let ((?v_2 (c_sort ?v_0 ?a1u410_350)) (?v_1 (c_sort (pointer ?t1u0_349) ?pu407_353))) (=> (and (valid ?v_2 ?v_1) (not (in_pset ?v_1 (c_sort (pset ?t1u0_349) ?lu408_352)))) (= (offset_max ?v_2 ?v_1) (offset_max (c_sort ?v_0 ?a2u409_351) ?v_1))))))))))))
(declare-fun bitvector () c_type)
(declare-fun concat_bitvector (c_sorted c_sorted) c_unsorted)
(declare-fun offset_min_bytes (c_sorted c_sorted Int) Int)
(declare-fun offset_max_bytes (c_sorted c_sorted Int) Int)
(assert (forall ((?t1u0_354 c_type)) (forall ((?au434_355 c_unsorted)) (forall ((?pu433_356 c_unsorted)) (forall ((?su432_357 Int)) (let ((?v_0 (c_sort (alloc_table ?t1u0_354) ?au434_355)) (?v_1 (c_sort (pointer ?t1u0_354) ?pu433_356))) (let ((?v_2 (* ?su432_357 (offset_min_bytes ?v_0 ?v_1 ?su432_357))) (?v_3 (offset_min ?v_0 ?v_1))) (=> (< 0 ?su432_357) (and (<= ?v_3 ?v_2) (< (- ?v_2 ?su432_357) ?v_3))))))))))
(assert (forall ((?t1u0_358 c_type)) (forall ((?au437_359 c_unsorted)) (forall ((?pu436_360 c_unsorted)) (forall ((?su435_361 Int)) (let ((?v_0 (c_sort (alloc_table ?t1u0_358) ?au437_359)) (?v_1 (c_sort (pointer ?t1u0_358) ?pu436_360))) (let ((?v_2 (offset_max ?v_0 ?v_1)) (?v_3 (+ (* ?su435_361 (offset_max_bytes ?v_0 ?v_1 ?su435_361)) ?su435_361))) (=> (< 0 ?su435_361) (and (<= (- ?v_3 1) ?v_2) (< ?v_2 (- (+ ?v_3 ?su435_361) 1)))))))))))
(declare-fun extract_bytes (c_sorted Int Int) c_unsorted)
(declare-fun replace_bytes (c_sorted Int Int c_sorted) c_unsorted)
(assert (forall ((?o1u443_362 Int)) (forall ((?s1u442_363 Int)) (forall ((?o2u441_364 Int)) (forall ((?s2u440_365 Int)) (forall ((?v1u439_366 c_unsorted)) (forall ((?v2u438_367 c_unsorted)) (let ((?v_0 (c_sort bitvector ?v2u438_367))) (=> (and (= ?o1u443_362 ?o2u441_364) (= ?s1u442_363 ?s2u440_365)) (= (c_sort bitvector (extract_bytes (c_sort bitvector (replace_bytes (c_sort bitvector ?v1u439_366) ?o1u443_362 ?s1u442_363 ?v_0)) ?o2u441_364 ?s2u440_365)) ?v_0))))))))))
(assert (forall ((?o1u449_368 Int)) (forall ((?s1u448_369 Int)) (forall ((?o2u447_370 Int)) (forall ((?s2u446_371 Int)) (forall ((?v1u445_372 c_unsorted)) (forall ((?v2u444_373 c_unsorted)) (let ((?v_0 (c_sort bitvector ?v1u445_372))) (=> (or (<= (+ ?o2u447_370 ?s2u446_371) ?o1u449_368) (<= (+ ?o1u449_368 ?s2u446_371) ?o2u447_370)) (= (c_sort bitvector (extract_bytes (c_sort bitvector (replace_bytes ?v_0 ?o1u449_368 ?s1u448_369 (c_sort bitvector ?v2u444_373))) ?o2u447_370 ?s2u446_371)) (c_sort bitvector (extract_bytes ?v_0 ?o2u447_370 ?s2u446_371))))))))))))
(assert (forall ((?o1u456_374 Int)) (forall ((?s1u455_375 Int)) (forall ((?o2u454_376 Int)) (forall ((?s2u453_377 Int)) (forall ((?v1u452_378 c_unsorted)) (forall ((?v2u451_379 c_unsorted)) (forall ((?v3u450_380 c_unsorted)) (let ((?v_0 (c_sort bitvector ?v1u452_378)) (?v_1 (c_sort bitvector ?v2u451_379)) (?v_2 (c_sort bitvector ?v3u450_380))) (=> (= (+ ?o1u456_374 ?s1u455_375) ?o2u454_376) (= (c_sort bitvector (replace_bytes (c_sort bitvector (replace_bytes ?v_0 ?o1u456_374 ?s1u455_375 ?v_1)) ?o2u454_376 ?s2u453_377 ?v_2)) (c_sort bitvector (replace_bytes ?v_0 ?o1u456_374 (+ ?s1u455_375 ?s2u453_377) (c_sort bitvector (concat_bitvector ?v_1 ?v_2)))))))))))))))
(assert (forall ((?o1u463_381 Int)) (forall ((?s1u462_382 Int)) (forall ((?o2u461_383 Int)) (forall ((?s2u460_384 Int)) (forall ((?v1u459_385 c_unsorted)) (forall ((?v2u458_386 c_unsorted)) (forall ((?v3u457_387 c_unsorted)) (let ((?v_0 (c_sort bitvector ?v1u459_385)) (?v_2 (c_sort bitvector ?v2u458_386)) (?v_1 (c_sort bitvector ?v3u457_387))) (=> (= (+ ?o2u461_383 ?s2u460_384) ?o1u463_381) (= (c_sort bitvector (replace_bytes (c_sort bitvector (replace_bytes ?v_0 ?o1u463_381 ?s1u462_382 ?v_2)) ?o2u461_383 ?s2u460_384 ?v_1)) (c_sort bitvector (replace_bytes ?v_0 ?o2u461_383 (+ ?s1u462_382 ?s2u460_384) (c_sort bitvector (concat_bitvector ?v_1 ?v_2)))))))))))))))
(assert (forall ((?o1u468_388 Int)) (forall ((?s1u467_389 Int)) (forall ((?o2u466_390 Int)) (forall ((?s2u465_391 Int)) (forall ((?vu464_392 c_unsorted)) (let ((?v_0 (c_sort bitvector ?vu464_392))) (=> (= (+ ?o1u468_388 ?s1u467_389) ?o2u466_390) (= (c_sort bitvector (concat_bitvector (c_sort bitvector (extract_bytes ?v_0 ?o1u468_388 ?s1u467_389)) (c_sort bitvector (extract_bytes ?v_0 ?o2u466_390 ?s2u465_391)))) (c_sort bitvector (extract_bytes ?v_0 ?o1u468_388 (+ ?s1u467_389 ?s2u465_391))))))))))))
(declare-fun select_bytes (c_sorted c_sorted Int Int) c_unsorted)
(declare-fun store_bytes (c_sorted c_sorted Int Int c_sorted) c_unsorted)
(assert (forall ((?t1u0_393 c_type)) (forall ((?mu476_394 c_unsorted)) (forall ((?p1u475_395 c_unsorted)) (forall ((?p2u474_396 c_unsorted)) (forall ((?o1u473_397 Int)) (forall ((?s1u472_398 Int)) (forall ((?o2u471_399 Int)) (forall ((?s2u470_400 Int)) (forall ((?vu469_401 c_unsorted)) (let ((?v_0 (pointer ?t1u0_393))) (let ((?v_2 (c_sort ?v_0 ?p1u475_395)) (?v_3 (c_sort ?v_0 ?p2u474_396)) (?v_1 (memory ?t1u0_393 bitvector)) (?v_4 (c_sort bitvector ?vu469_401))) (=> (and (= ?v_2 ?v_3) (and (= ?o1u473_397 ?o2u471_399) (= ?s1u472_398 ?s2u470_400))) (= (c_sort bitvector (select_bytes (c_sort ?v_1 (store_bytes (c_sort ?v_1 ?mu476_394) ?v_2 ?o1u473_397 ?s1u472_398 ?v_4)) ?v_3 ?o2u471_399 ?s2u470_400)) ?v_4))))))))))))))
(assert (forall ((?t1u0_402 c_type)) (forall ((?mu484_403 c_unsorted)) (forall ((?p1u483_404 c_unsorted)) (forall ((?p2u482_405 c_unsorted)) (forall ((?o1u481_406 Int)) (forall ((?s1u480_407 Int)) (forall ((?o2u479_408 Int)) (forall ((?s2u478_409 Int)) (forall ((?vu477_410 c_unsorted)) (let ((?v_0 (pset ?t1u0_402)) (?v_1 (pointer ?t1u0_402))) (let ((?v_3 (c_sort ?v_1 ?p1u483_404)) (?v_4 (c_sort ?v_1 ?p2u482_405)) (?v_2 (memory ?t1u0_402 bitvector))) (let ((?v_5 (c_sort ?v_2 ?mu484_403))) (=> (pset_disjoint (c_sort ?v_0 (pset_range (c_sort ?v_0 (pset_singleton ?v_3)) ?o1u481_406 (+ ?o1u481_406 ?s1u480_407))) (c_sort ?v_0 (pset_range (c_sort ?v_0 (pset_singleton ?v_4)) ?o2u479_408 (+ ?o2u479_408 ?s2u478_409)))) (= (c_sort bitvector (select_bytes (c_sort ?v_2 (store_bytes ?v_5 ?v_3 ?o1u481_406 ?s1u480_407 (c_sort bitvector ?vu477_410))) ?v_4 ?o2u479_408 ?s2u478_409)) (c_sort bitvector (select_bytes ?v_5 ?v_4 ?o2u479_408 ?s2u478_409)))))))))))))))))
(assert (forall ((?t1u0_411 c_type)) (forall ((?mu490_412 c_unsorted)) (forall ((?pu489_413 c_unsorted)) (forall ((?iu488_414 Int)) (forall ((?ou487_415 Int)) (forall ((?su486_416 Int)) (forall ((?vu485_417 c_unsorted)) (let ((?v_0 (memory ?t1u0_411 bitvector))) (let ((?v_2 (c_sort ?v_0 ?mu490_412)) (?v_1 (pointer ?t1u0_411))) (let ((?v_3 (c_sort ?v_1 ?pu489_413)) (?v_4 (c_sort bitvector ?vu485_417))) (= (c_sort ?v_0 (store_bytes ?v_2 (c_sort ?v_1 (shift ?v_3 ?iu488_414)) ?ou487_415 ?su486_416 ?v_4)) (c_sort ?v_0 (store_bytes ?v_2 ?v_3 (+ ?ou487_415 ?iu488_414) ?su486_416 ?v_4))))))))))))))
(assert (forall ((?t1u0_418 c_type)) (forall ((?mu496_419 c_unsorted)) (forall ((?pu495_420 c_unsorted)) (forall ((?iu494_421 Int)) (forall ((?ou493_422 Int)) (forall ((?su492_423 Int)) (forall ((?vu491_424 c_unsorted)) (let ((?v_1 (c_sort (memory ?t1u0_418 bitvector) ?mu496_419)) (?v_0 (pointer ?t1u0_418))) (let ((?v_2 (c_sort ?v_0 ?pu495_420))) (= (c_sort bitvector (select_bytes ?v_1 (c_sort ?v_0 (shift ?v_2 ?iu494_421)) ?ou493_422 ?su492_423)) (c_sort bitvector (select_bytes ?v_1 ?v_2 (+ ?ou493_422 ?iu494_421) ?su492_423)))))))))))))
(assert (forall ((?t1u0_425 c_type)) (forall ((?mu504_426 c_unsorted)) (forall ((?pu503_427 c_unsorted)) (forall ((?o1u502_428 Int)) (forall ((?s1u501_429 Int)) (forall ((?o2u500_430 Int)) (forall ((?s2u499_431 Int)) (forall ((?v1u498_432 c_unsorted)) (forall ((?v2u497_433 c_unsorted)) (let ((?v_0 (memory ?t1u0_425 bitvector))) (let ((?v_2 (c_sort ?v_0 ?mu504_426)) (?v_1 (c_sort (pointer ?t1u0_425) ?pu503_427)) (?v_3 (c_sort bitvector ?v1u498_432)) (?v_4 (c_sort bitvector ?v2u497_433))) (=> (= (+ ?o1u502_428 ?s1u501_429) ?o2u500_430) (= (c_sort ?v_0 (store_bytes (c_sort ?v_0 (store_bytes ?v_2 ?v_1 ?o1u502_428 ?s1u501_429 ?v_3)) ?v_1 ?o2u500_430 ?s2u499_431 ?v_4)) (c_sort ?v_0 (store_bytes ?v_2 ?v_1 ?o1u502_428 (+ ?s1u501_429 ?s2u499_431) (c_sort bitvector (concat_bitvector ?v_3 ?v_4))))))))))))))))))
(assert (forall ((?t1u0_434 c_type)) (forall ((?mu512_435 c_unsorted)) (forall ((?pu511_436 c_unsorted)) (forall ((?o1u510_437 Int)) (forall ((?s1u509_438 Int)) (forall ((?o2u508_439 Int)) (forall ((?s2u507_440 Int)) (forall ((?v1u506_441 c_unsorted)) (forall ((?v2u505_442 c_unsorted)) (let ((?v_0 (memory ?t1u0_434 bitvector))) (let ((?v_2 (c_sort ?v_0 ?mu512_435)) (?v_1 (c_sort (pointer ?t1u0_434) ?pu511_436)) (?v_4 (c_sort bitvector ?v1u506_441)) (?v_3 (c_sort bitvector ?v2u505_442))) (=> (= (+ ?o2u508_439 ?s2u507_440) ?o1u510_437) (= (c_sort ?v_0 (store_bytes (c_sort ?v_0 (store_bytes ?v_2 ?v_1 ?o1u510_437 ?s1u509_438 ?v_4)) ?v_1 ?o2u508_439 ?s2u507_440 ?v_3)) (c_sort ?v_0 (store_bytes ?v_2 ?v_1 ?o2u508_439 (+ ?s1u509_438 ?s2u507_440) (c_sort bitvector (concat_bitvector ?v_3 ?v_4))))))))))))))))))
(assert (forall ((?t1u0_443 c_type)) (forall ((?mu518_444 c_unsorted)) (forall ((?pu517_445 c_unsorted)) (forall ((?o1u516_446 Int)) (forall ((?s1u515_447 Int)) (forall ((?o2u514_448 Int)) (forall ((?s2u513_449 Int)) (let ((?v_0 (c_sort (memory ?t1u0_443 bitvector) ?mu518_444)) (?v_1 (c_sort (pointer ?t1u0_443) ?pu517_445))) (=> (= (+ ?o1u516_446 ?s1u515_447) ?o2u514_448) (= (c_sort bitvector (concat_bitvector (c_sort bitvector (select_bytes ?v_0 ?v_1 ?o1u516_446 ?s1u515_447)) (c_sort bitvector (select_bytes ?v_0 ?v_1 ?o2u514_448 ?s2u513_449)))) (c_sort bitvector (select_bytes ?v_0 ?v_1 ?o1u516_446 (+ ?s1u515_447 ?s2u513_449))))))))))))))
(declare-fun char_P () c_type)
(declare-fun int_P () c_type)
(declare-fun padding () c_type)
(declare-fun void_P () c_type)
(declare-fun bitvector_of_char_P (c_sorted) c_unsorted)
(declare-fun char_P_of_bitvector (c_sorted) c_unsorted)
(assert (forall ((?xu539_450 c_unsorted)) (let ((?v_0 (c_sort bitvector ?xu539_450))) (= (c_sort bitvector (bitvector_of_char_P (c_sort (pointer char_P) (char_P_of_bitvector ?v_0)))) ?v_0))))
(declare-fun bitvector_of_int_P (c_sorted) c_unsorted)
(declare-fun int_P_of_bitvector (c_sorted) c_unsorted)
(assert (forall ((?xu540_451 c_unsorted)) (let ((?v_0 (c_sort bitvector ?xu540_451))) (= (c_sort bitvector (bitvector_of_int_P (c_sort (pointer int_P) (int_P_of_bitvector ?v_0)))) ?v_0))))
(declare-fun bitvector_of_void_P (c_sorted) c_unsorted)
(declare-fun void_P_of_bitvector (c_sorted) c_unsorted)
(assert (forall ((?xu541_452 c_unsorted)) (let ((?v_0 (c_sort bitvector ?xu541_452))) (= (c_sort bitvector (bitvector_of_void_P (c_sort (pointer void_P) (void_P_of_bitvector ?v_0)))) ?v_0))))
(declare-fun char_P_tag () c_unsorted)
(assert (= (int_of_tag (c_sort (tag_id char_P) char_P_tag)) 1))
(assert (forall ((?xu542_453 c_unsorted)) (let ((?v_0 (pointer char_P))) (let ((?v_1 (c_sort ?v_0 ?xu542_453))) (= (c_sort ?v_0 (char_P_of_bitvector (c_sort bitvector (bitvector_of_char_P ?v_1)))) ?v_1)))))
(declare-fun char_P_of_pointer_address (c_sorted) c_unsorted)
(assert (forall ((?pu543_454 c_unsorted)) (let ((?v_0 (pointer char_P))) (let ((?v_1 (c_sort ?v_0 ?pu543_454))) (= ?v_1 (c_sort ?v_0 (char_P_of_pointer_address (c_sort (pointer c_unit) (pointer_address ?v_1)))))))))
(assert (let ((?v_0 (tag_id char_P))) (parenttag (c_sort ?v_0 char_P_tag) (c_sort ?v_0 bottom_tag))))
(assert (forall ((?xu545_455 c_unsorted)) (forall ((?charuPutagutableu544_456 c_unsorted)) (instanceof (c_sort (tag_table char_P) ?charuPutagutableu544_456) (c_sort (pointer char_P) ?xu545_455) (c_sort (tag_id char_P) char_P_tag)))))
(declare-fun int_P_tag () c_unsorted)
(assert (= (int_of_tag (c_sort (tag_id int_P) int_P_tag)) 1))
(assert (forall ((?xu546_457 c_unsorted)) (let ((?v_0 (pointer int_P))) (let ((?v_1 (c_sort ?v_0 ?xu546_457))) (= (c_sort ?v_0 (int_P_of_bitvector (c_sort bitvector (bitvector_of_int_P ?v_1)))) ?v_1)))))
(declare-fun int_P_of_pointer_address (c_sorted) c_unsorted)
(assert (forall ((?pu547_458 c_unsorted)) (let ((?v_0 (pointer int_P))) (let ((?v_1 (c_sort ?v_0 ?pu547_458))) (= ?v_1 (c_sort ?v_0 (int_P_of_pointer_address (c_sort (pointer c_unit) (pointer_address ?v_1)))))))))
(assert (let ((?v_0 (tag_id int_P))) (parenttag (c_sort ?v_0 int_P_tag) (c_sort ?v_0 bottom_tag))))
(assert (forall ((?xu549_459 c_unsorted)) (forall ((?intuPutagutableu548_460 c_unsorted)) (instanceof (c_sort (tag_table int_P) ?intuPutagutableu548_460) (c_sort (pointer int_P) ?xu549_459) (c_sort (tag_id int_P) int_P_tag)))))
(declare-fun left_valid_struct_char_P (c_sorted Int c_sorted) Bool)
(assert (forall ((?pu0_461 c_unsorted)) (forall ((?au0_462 Int)) (forall ((?charuPuallocutableu0_463 c_unsorted)) (let ((?v_1 (c_sort (pointer char_P) ?pu0_461)) (?v_0 (c_sort (alloc_table char_P) ?charuPuallocutableu0_463))) (= (left_valid_struct_char_P ?v_1 ?au0_462 ?v_0) (<= (offset_min ?v_0 ?v_1) ?au0_462)))))))
(declare-fun left_valid_struct_int_P (c_sorted Int c_sorted) Bool)
(assert (forall ((?pu0_464 c_unsorted)) (forall ((?au0_465 Int)) (forall ((?intuPuallocutableu0_466 c_unsorted)) (let ((?v_1 (c_sort (pointer int_P) ?pu0_464)) (?v_0 (c_sort (alloc_table int_P) ?intuPuallocutableu0_466))) (= (left_valid_struct_int_P ?v_1 ?au0_465 ?v_0) (<= (offset_min ?v_0 ?v_1) ?au0_465)))))))
(declare-fun left_valid_struct_void_P (c_sorted Int c_sorted) Bool)
(assert (forall ((?pu0_467 c_unsorted)) (forall ((?au0_468 Int)) (forall ((?voiduPuallocutableu0_469 c_unsorted)) (let ((?v_1 (c_sort (pointer void_P) ?pu0_467)) (?v_0 (c_sort (alloc_table void_P) ?voiduPuallocutableu0_469))) (= (left_valid_struct_void_P ?v_1 ?au0_468 ?v_0) (<= (offset_min ?v_0 ?v_1) ?au0_468)))))))
(assert (forall ((?pu550_470 c_unsorted)) (let ((?v_0 (pointer c_unit))) (let ((?v_1 (c_sort ?v_0 ?pu550_470))) (= ?v_1 (c_sort ?v_0 (pointer_address (c_sort (pointer char_P) (char_P_of_pointer_address ?v_1)))))))))
(assert (forall ((?pu551_471 c_unsorted)) (let ((?v_0 (pointer c_unit))) (let ((?v_1 (c_sort ?v_0 ?pu551_471))) (= ?v_1 (c_sort ?v_0 (pointer_address (c_sort (pointer int_P) (int_P_of_pointer_address ?v_1)))))))))
(declare-fun void_P_of_pointer_address (c_sorted) c_unsorted)
(assert (forall ((?pu552_472 c_unsorted)) (let ((?v_0 (pointer c_unit))) (let ((?v_1 (c_sort ?v_0 ?pu552_472))) (= ?v_1 (c_sort ?v_0 (pointer_address (c_sort (pointer void_P) (void_P_of_pointer_address ?v_1)))))))))
(declare-fun right_valid_struct_char_P (c_sorted Int c_sorted) Bool)
(assert (forall ((?pu0_473 c_unsorted)) (forall ((?bu0_474 Int)) (forall ((?charuPuallocutableu0_475 c_unsorted)) (let ((?v_1 (c_sort (pointer char_P) ?pu0_473)) (?v_0 (c_sort (alloc_table char_P) ?charuPuallocutableu0_475))) (= (right_valid_struct_char_P ?v_1 ?bu0_474 ?v_0) (>= (offset_max ?v_0 ?v_1) ?bu0_474)))))))
(declare-fun right_valid_struct_int_P (c_sorted Int c_sorted) Bool)
(assert (forall ((?pu0_476 c_unsorted)) (forall ((?bu0_477 Int)) (forall ((?intuPuallocutableu0_478 c_unsorted)) (let ((?v_1 (c_sort (pointer int_P) ?pu0_476)) (?v_0 (c_sort (alloc_table int_P) ?intuPuallocutableu0_478))) (= (right_valid_struct_int_P ?v_1 ?bu0_477 ?v_0) (>= (offset_max ?v_0 ?v_1) ?bu0_477)))))))
(declare-fun right_valid_struct_void_P (c_sorted Int c_sorted) Bool)
(assert (forall ((?pu0_479 c_unsorted)) (forall ((?bu0_480 Int)) (forall ((?voiduPuallocutableu0_481 c_unsorted)) (let ((?v_1 (c_sort (pointer void_P) ?pu0_479)) (?v_0 (c_sort (alloc_table void_P) ?voiduPuallocutableu0_481))) (= (right_valid_struct_void_P ?v_1 ?bu0_480 ?v_0) (>= (offset_max ?v_0 ?v_1) ?bu0_480)))))))
(declare-fun strict_valid_root_char_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_482 c_unsorted)) (forall ((?au0_483 Int)) (forall ((?bu0_484 Int)) (forall ((?charuPuallocutableu0_485 c_unsorted)) (let ((?v_1 (c_sort (pointer char_P) ?pu0_482)) (?v_0 (c_sort (alloc_table char_P) ?charuPuallocutableu0_485))) (= (strict_valid_root_char_P ?v_1 ?au0_483 ?bu0_484 ?v_0) (and (= (offset_min ?v_0 ?v_1) ?au0_483) (= (offset_max ?v_0 ?v_1) ?bu0_484)))))))))
(declare-fun strict_valid_root_int_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_486 c_unsorted)) (forall ((?au0_487 Int)) (forall ((?bu0_488 Int)) (forall ((?intuPuallocutableu0_489 c_unsorted)) (let ((?v_1 (c_sort (pointer int_P) ?pu0_486)) (?v_0 (c_sort (alloc_table int_P) ?intuPuallocutableu0_489))) (= (strict_valid_root_int_P ?v_1 ?au0_487 ?bu0_488 ?v_0) (and (= (offset_min ?v_0 ?v_1) ?au0_487) (= (offset_max ?v_0 ?v_1) ?bu0_488)))))))))
(declare-fun strict_valid_root_void_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_490 c_unsorted)) (forall ((?au0_491 Int)) (forall ((?bu0_492 Int)) (forall ((?voiduPuallocutableu0_493 c_unsorted)) (let ((?v_1 (c_sort (pointer void_P) ?pu0_490)) (?v_0 (c_sort (alloc_table void_P) ?voiduPuallocutableu0_493))) (= (strict_valid_root_void_P ?v_1 ?au0_491 ?bu0_492 ?v_0) (and (= (offset_min ?v_0 ?v_1) ?au0_491) (= (offset_max ?v_0 ?v_1) ?bu0_492)))))))))
(declare-fun strict_valid_struct_char_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_494 c_unsorted)) (forall ((?au0_495 Int)) (forall ((?bu0_496 Int)) (forall ((?charuPuallocutableu0_497 c_unsorted)) (let ((?v_1 (c_sort (pointer char_P) ?pu0_494)) (?v_0 (c_sort (alloc_table char_P) ?charuPuallocutableu0_497))) (= (strict_valid_struct_char_P ?v_1 ?au0_495 ?bu0_496 ?v_0) (and (= (offset_min ?v_0 ?v_1) ?au0_495) (= (offset_max ?v_0 ?v_1) ?bu0_496)))))))))
(declare-fun strict_valid_struct_int_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_498 c_unsorted)) (forall ((?au0_499 Int)) (forall ((?bu0_500 Int)) (forall ((?intuPuallocutableu0_501 c_unsorted)) (let ((?v_1 (c_sort (pointer int_P) ?pu0_498)) (?v_0 (c_sort (alloc_table int_P) ?intuPuallocutableu0_501))) (= (strict_valid_struct_int_P ?v_1 ?au0_499 ?bu0_500 ?v_0) (and (= (offset_min ?v_0 ?v_1) ?au0_499) (= (offset_max ?v_0 ?v_1) ?bu0_500)))))))))
(declare-fun strict_valid_struct_void_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_502 c_unsorted)) (forall ((?au0_503 Int)) (forall ((?bu0_504 Int)) (forall ((?voiduPuallocutableu0_505 c_unsorted)) (let ((?v_1 (c_sort (pointer void_P) ?pu0_502)) (?v_0 (c_sort (alloc_table void_P) ?voiduPuallocutableu0_505))) (= (strict_valid_struct_void_P ?v_1 ?au0_503 ?bu0_504 ?v_0) (and (= (offset_min ?v_0 ?v_1) ?au0_503) (= (offset_max ?v_0 ?v_1) ?bu0_504)))))))))
(declare-fun valid_bitvector_struct_char_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_506 c_unsorted)) (forall ((?au0_507 Int)) (forall ((?bu0_508 Int)) (forall ((?bitvectoruallocutableu0_509 c_unsorted)) (let ((?v_1 (c_sort (pointer c_unit) ?pu0_506)) (?v_0 (c_sort (alloc_table c_unit) ?bitvectoruallocutableu0_509))) (= (valid_bitvector_struct_char_P ?v_1 ?au0_507 ?bu0_508 ?v_0) (and (= (offset_min ?v_0 ?v_1) ?au0_507) (= (offset_max ?v_0 ?v_1) ?bu0_508)))))))))
(declare-fun valid_bitvector_struct_int_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_510 c_unsorted)) (forall ((?au0_511 Int)) (forall ((?bu0_512 Int)) (forall ((?bitvectoruallocutableu0_513 c_unsorted)) (let ((?v_1 (c_sort (pointer c_unit) ?pu0_510)) (?v_0 (c_sort (alloc_table c_unit) ?bitvectoruallocutableu0_513))) (= (valid_bitvector_struct_int_P ?v_1 ?au0_511 ?bu0_512 ?v_0) (and (= (offset_min ?v_0 ?v_1) ?au0_511) (= (offset_max ?v_0 ?v_1) ?bu0_512)))))))))
(declare-fun valid_bitvector_struct_void_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_514 c_unsorted)) (forall ((?au0_515 Int)) (forall ((?bu0_516 Int)) (forall ((?bitvectoruallocutableu0_517 c_unsorted)) (let ((?v_1 (c_sort (pointer c_unit) ?pu0_514)) (?v_0 (c_sort (alloc_table c_unit) ?bitvectoruallocutableu0_517))) (= (valid_bitvector_struct_void_P ?v_1 ?au0_515 ?bu0_516 ?v_0) (and (= (offset_min ?v_0 ?v_1) ?au0_515) (= (offset_max ?v_0 ?v_1) ?bu0_516)))))))))
(declare-fun valid_root_char_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_518 c_unsorted)) (forall ((?au0_519 Int)) (forall ((?bu0_520 Int)) (forall ((?charuPuallocutableu0_521 c_unsorted)) (let ((?v_1 (c_sort (pointer char_P) ?pu0_518)) (?v_0 (c_sort (alloc_table char_P) ?charuPuallocutableu0_521))) (= (valid_root_char_P ?v_1 ?au0_519 ?bu0_520 ?v_0) (and (<= (offset_min ?v_0 ?v_1) ?au0_519) (>= (offset_max ?v_0 ?v_1) ?bu0_520)))))))))
(declare-fun valid_root_int_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_522 c_unsorted)) (forall ((?au0_523 Int)) (forall ((?bu0_524 Int)) (forall ((?intuPuallocutableu0_525 c_unsorted)) (let ((?v_1 (c_sort (pointer int_P) ?pu0_522)) (?v_0 (c_sort (alloc_table int_P) ?intuPuallocutableu0_525))) (= (valid_root_int_P ?v_1 ?au0_523 ?bu0_524 ?v_0) (and (<= (offset_min ?v_0 ?v_1) ?au0_523) (>= (offset_max ?v_0 ?v_1) ?bu0_524)))))))))
(declare-fun valid_root_void_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_526 c_unsorted)) (forall ((?au0_527 Int)) (forall ((?bu0_528 Int)) (forall ((?voiduPuallocutableu0_529 c_unsorted)) (let ((?v_1 (c_sort (pointer void_P) ?pu0_526)) (?v_0 (c_sort (alloc_table void_P) ?voiduPuallocutableu0_529))) (= (valid_root_void_P ?v_1 ?au0_527 ?bu0_528 ?v_0) (and (<= (offset_min ?v_0 ?v_1) ?au0_527) (>= (offset_max ?v_0 ?v_1) ?bu0_528)))))))))
(declare-fun valid_struct_char_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_530 c_unsorted)) (forall ((?au0_531 Int)) (forall ((?bu0_532 Int)) (forall ((?charuPuallocutableu0_533 c_unsorted)) (let ((?v_1 (c_sort (pointer char_P) ?pu0_530)) (?v_0 (c_sort (alloc_table char_P) ?charuPuallocutableu0_533))) (= (valid_struct_char_P ?v_1 ?au0_531 ?bu0_532 ?v_0) (and (<= (offset_min ?v_0 ?v_1) ?au0_531) (>= (offset_max ?v_0 ?v_1) ?bu0_532)))))))))
(declare-fun valid_struct_int_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_534 c_unsorted)) (forall ((?au0_535 Int)) (forall ((?bu0_536 Int)) (forall ((?intuPuallocutableu0_537 c_unsorted)) (let ((?v_1 (c_sort (pointer int_P) ?pu0_534)) (?v_0 (c_sort (alloc_table int_P) ?intuPuallocutableu0_537))) (= (valid_struct_int_P ?v_1 ?au0_535 ?bu0_536 ?v_0) (and (<= (offset_min ?v_0 ?v_1) ?au0_535) (>= (offset_max ?v_0 ?v_1) ?bu0_536)))))))))
(declare-fun valid_struct_void_P (c_sorted Int Int c_sorted) Bool)
(assert (forall ((?pu0_538 c_unsorted)) (forall ((?au0_539 Int)) (forall ((?bu0_540 Int)) (forall ((?voiduPuallocutableu0_541 c_unsorted)) (let ((?v_1 (c_sort (pointer void_P) ?pu0_538)) (?v_0 (c_sort (alloc_table void_P) ?voiduPuallocutableu0_541))) (= (valid_struct_void_P ?v_1 ?au0_539 ?bu0_540 ?v_0) (and (<= (offset_min ?v_0 ?v_1) ?au0_539) (>= (offset_max ?v_0 ?v_1) ?bu0_540)))))))))
(declare-fun void_P_tag () c_unsorted)
(assert (= (int_of_tag (c_sort (tag_id void_P) void_P_tag)) 1))
(assert (forall ((?xu553_542 c_unsorted)) (let ((?v_0 (pointer void_P))) (let ((?v_1 (c_sort ?v_0 ?xu553_542))) (= (c_sort ?v_0 (void_P_of_bitvector (c_sort bitvector (bitvector_of_void_P ?v_1)))) ?v_1)))))
(assert (forall ((?pu554_543 c_unsorted)) (let ((?v_0 (pointer void_P))) (let ((?v_1 (c_sort ?v_0 ?pu554_543))) (= ?v_1 (c_sort ?v_0 (void_P_of_pointer_address (c_sort (pointer c_unit) (pointer_address ?v_1)))))))))
(assert (let ((?v_0 (tag_id void_P))) (parenttag (c_sort ?v_0 void_P_tag) (c_sort ?v_0 bottom_tag))))
(assert (forall ((?xu556_544 c_unsorted)) (forall ((?voiduPutagutableu555_545 c_unsorted)) (instanceof (c_sort (tag_table void_P) ?voiduPutagutableu555_545) (c_sort (pointer void_P) ?xu556_544) (c_sort (tag_id void_P) void_P_tag)))))
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (= c_Boolean_true c_Boolean_true) (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1))))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (<= 0 ?i))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (= c_Boolean_true c_Boolean_true) (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1))))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (<= ?i ?n))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (= c_Boolean_true c_Boolean_true) (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1))))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?ku597_546 Int)) (let ((?v_2 (pointer int_P))) (let ((?v_3 (s2int (c_sort c_int (smtlib__select (c_sort (memory int_P c_int) ?int_P_int_M_t_1) (c_sort ?v_2 (shift ?v_1 ?ku597_546))))))) (=> (and (<= 0 ?ku597_546) (< ?ku597_546 ?i)) (= ?v_3 (- ?v_3))))))))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (= c_Boolean_true c_Boolean_true) (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1))))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?pu321_547 c_unsorted)) (let ((?v_4 (pointer int_P))) (let ((?v_2 (c_sort ?v_4 ?pu321_547)) (?v_3 (pset int_P))) (let ((?v_5 (c_sort c_int (smtlib__select (c_sort (memory int_P c_int) ?int_P_int_M_t_1) ?v_2)))) (=> (and (and (<= (offset_min ?v_0 ?v_2) 0) (>= (offset_max ?v_0 ?v_2) 0)) (not (in_pset ?v_2 (c_sort ?v_3 (pset_range (c_sort ?v_3 (pset_singleton ?v_1)) 0 (- ?i 1)))))) (= ?v_5 ?v_5))))))))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (= c_Boolean_true c_Boolean_true) (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1))))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?pu321_548 c_unsorted)) (let ((?v_4 (pointer int_P)) (?v_3 (pset int_P))) (let ((?v_2 (c_sort ?v_4 ?pu321_548))) (let ((?v_5 (c_sort c_int (smtlib__select (c_sort (memory int_P c_int) ?int_P_int_M_t_1) ?v_2)))) (=> (and (and (<= (offset_min ?v_0 ?v_2) 0) (>= (offset_max ?v_0 ?v_2) 0)) (not (in_pset ?v_2 (c_sort ?v_3 (pset_range (c_sort ?v_3 (pset_singleton ?v_1)) 0 (- ?n 1)))))) (= ?v_5 ?v_5))))))))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (= c_Boolean_true c_Boolean_true) (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1))))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?i0 Int)) (forall ((?int_P_int_M_t_1_0 c_unsorted)) (let ((?v_2 (memory int_P c_int)) (?v_3 (pset int_P))) (let ((?v_5 (c_sort ?v_2 ?int_P_int_M_t_1_0)) (?v_4 (c_sort ?v_2 ?int_P_int_M_t_1)) (?v_6 (c_sort ?v_3 (pset_singleton ?v_1)))) (=> (and (and (<= 0 ?i0) (and (<= ?i0 ?n) (forall ((?ku597_549 Int)) (let ((?v_7 (pointer int_P))) (let ((?v_8 (c_sort ?v_7 (shift ?v_1 ?ku597_549)))) (=> (and (<= 0 ?ku597_549) (< ?ku597_549 ?i0)) (= (s2int (c_sort c_int (smtlib__select ?v_5 ?v_8))) (- (s2int (c_sort c_int (smtlib__select ?v_4 ?v_8))))))))))) (and (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?i0 1)))) (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?n 1)))))) (=> (< ?i0 ?n) (forall ((?result c_unsorted)) (let ((?v_9 (pointer int_P))) (=> (= (c_sort c_int ?result) (c_sort c_int (smtlib__select ?v_5 (c_sort ?v_9 (shift ?v_1 ?i0))))) (forall ((?int_P_int_M_t_1_1 c_unsorted)) (=> (= (c_sort ?v_2 ?int_P_int_M_t_1_1) (c_sort ?v_2 (smtlib__store ?v_5 (c_sort ?v_9 (shift ?v_1 ?i0)) (c_sort c_int (int2u (- (s2int (c_sort c_int ?result)))))))) (forall ((?i1 Int)) (=> (= (c_sort c_int (int2u ?i1)) (c_sort c_int (int2u (+ ?i0 1)))) (<= 0 ?i1))))))))))))))))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (= c_Boolean_true c_Boolean_true) (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1))))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?i0 Int)) (forall ((?int_P_int_M_t_1_0 c_unsorted)) (let ((?v_2 (memory int_P c_int)) (?v_3 (pset int_P))) (let ((?v_5 (c_sort ?v_2 ?int_P_int_M_t_1_0)) (?v_4 (c_sort ?v_2 ?int_P_int_M_t_1)) (?v_6 (c_sort ?v_3 (pset_singleton ?v_1)))) (=> (and (and (<= 0 ?i0) (and (<= ?i0 ?n) (forall ((?ku597_550 Int)) (let ((?v_7 (pointer int_P))) (let ((?v_8 (c_sort ?v_7 (shift ?v_1 ?ku597_550)))) (=> (and (<= 0 ?ku597_550) (< ?ku597_550 ?i0)) (= (s2int (c_sort c_int (smtlib__select ?v_5 ?v_8))) (- (s2int (c_sort c_int (smtlib__select ?v_4 ?v_8))))))))))) (and (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?i0 1)))) (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?n 1)))))) (=> (< ?i0 ?n) (forall ((?result c_unsorted)) (let ((?v_9 (pointer int_P))) (=> (= (c_sort c_int ?result) (c_sort c_int (smtlib__select ?v_5 (c_sort ?v_9 (shift ?v_1 ?i0))))) (forall ((?int_P_int_M_t_1_1 c_unsorted)) (=> (= (c_sort ?v_2 ?int_P_int_M_t_1_1) (c_sort ?v_2 (smtlib__store ?v_5 (c_sort ?v_9 (shift ?v_1 ?i0)) (c_sort c_int (int2u (- (s2int (c_sort c_int ?result)))))))) (forall ((?i1 Int)) (=> (= (c_sort c_int (int2u ?i1)) (c_sort c_int (int2u (+ ?i0 1)))) (<= ?i1 ?n))))))))))))))))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (= c_Boolean_true c_Boolean_true) (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1))))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?i0 Int)) (forall ((?int_P_int_M_t_1_0 c_unsorted)) (let ((?v_2 (memory int_P c_int)) (?v_3 (pset int_P))) (let ((?v_5 (c_sort ?v_2 ?int_P_int_M_t_1_0)) (?v_4 (c_sort ?v_2 ?int_P_int_M_t_1)) (?v_6 (c_sort ?v_3 (pset_singleton ?v_1)))) (=> (and (and (<= 0 ?i0) (and (<= ?i0 ?n) (forall ((?ku597_551 Int)) (let ((?v_7 (pointer int_P))) (let ((?v_8 (c_sort ?v_7 (shift ?v_1 ?ku597_551)))) (=> (and (<= 0 ?ku597_551) (< ?ku597_551 ?i0)) (= (s2int (c_sort c_int (smtlib__select ?v_5 ?v_8))) (- (s2int (c_sort c_int (smtlib__select ?v_4 ?v_8))))))))))) (and (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?i0 1)))) (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?n 1)))))) (=> (< ?i0 ?n) (forall ((?result c_unsorted)) (let ((?v_9 (pointer int_P))) (=> (= (c_sort c_int ?result) (c_sort c_int (smtlib__select ?v_5 (c_sort ?v_9 (shift ?v_1 ?i0))))) (forall ((?int_P_int_M_t_1_1 c_unsorted)) (=> (= (c_sort ?v_2 ?int_P_int_M_t_1_1) (c_sort ?v_2 (smtlib__store ?v_5 (c_sort ?v_9 (shift ?v_1 ?i0)) (c_sort c_int (int2u (- (s2int (c_sort c_int ?result)))))))) (forall ((?i1 Int)) (=> (= (c_sort c_int (int2u ?i1)) (c_sort c_int (int2u (+ ?i0 1)))) (forall ((?ku597_552 Int)) (let ((?v_10 (c_sort ?v_9 (shift ?v_1 ?ku597_552)))) (=> (and (<= 0 ?ku597_552) (< ?ku597_552 ?i1)) (= (s2int (c_sort c_int (smtlib__select (c_sort ?v_2 ?int_P_int_M_t_1_1) ?v_10))) (- (s2int (c_sort c_int (smtlib__select ?v_4 ?v_10)))))))))))))))))))))))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (= c_Boolean_true c_Boolean_true) (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1))))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?i0 Int)) (forall ((?int_P_int_M_t_1_0 c_unsorted)) (let ((?v_2 (memory int_P c_int)) (?v_3 (pset int_P))) (let ((?v_5 (c_sort ?v_2 ?int_P_int_M_t_1_0)) (?v_4 (c_sort ?v_2 ?int_P_int_M_t_1)) (?v_6 (c_sort ?v_3 (pset_singleton ?v_1)))) (=> (and (and (<= 0 ?i0) (and (<= ?i0 ?n) (forall ((?ku597_553 Int)) (let ((?v_7 (pointer int_P))) (let ((?v_8 (c_sort ?v_7 (shift ?v_1 ?ku597_553)))) (=> (and (<= 0 ?ku597_553) (< ?ku597_553 ?i0)) (= (s2int (c_sort c_int (smtlib__select ?v_5 ?v_8))) (- (s2int (c_sort c_int (smtlib__select ?v_4 ?v_8))))))))))) (and (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?i0 1)))) (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?n 1)))))) (=> (< ?i0 ?n) (forall ((?result c_unsorted)) (let ((?v_9 (pointer int_P))) (=> (= (c_sort c_int ?result) (c_sort c_int (smtlib__select ?v_5 (c_sort ?v_9 (shift ?v_1 ?i0))))) (forall ((?int_P_int_M_t_1_1 c_unsorted)) (=> (= (c_sort ?v_2 ?int_P_int_M_t_1_1) (c_sort ?v_2 (smtlib__store ?v_5 (c_sort ?v_9 (shift ?v_1 ?i0)) (c_sort c_int (int2u (- (s2int (c_sort c_int ?result)))))))) (forall ((?i1 Int)) (=> (= (c_sort c_int (int2u ?i1)) (c_sort c_int (int2u (+ ?i0 1)))) (forall ((?pu321_554 c_unsorted)) (let ((?v_10 (c_sort ?v_9 ?pu321_554))) (=> (and (and (<= (offset_min ?v_0 ?v_10) 0) (>= (offset_max ?v_0 ?v_10) 0)) (not (in_pset ?v_10 (c_sort ?v_3 (pset_range ?v_6 0 (- ?i1 1)))))) (= (c_sort c_int (smtlib__select (c_sort ?v_2 ?int_P_int_M_t_1_1) ?v_10)) (c_sort c_int (smtlib__select ?v_4 ?v_10)))))))))))))))))))))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (= c_Boolean_true c_Boolean_true) (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1))))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?i0 Int)) (forall ((?int_P_int_M_t_1_0 c_unsorted)) (let ((?v_2 (memory int_P c_int)) (?v_3 (pset int_P))) (let ((?v_5 (c_sort ?v_2 ?int_P_int_M_t_1_0)) (?v_4 (c_sort ?v_2 ?int_P_int_M_t_1)) (?v_6 (c_sort ?v_3 (pset_singleton ?v_1)))) (=> (and (and (<= 0 ?i0) (and (<= ?i0 ?n) (forall ((?ku597_555 Int)) (let ((?v_7 (pointer int_P))) (let ((?v_8 (c_sort ?v_7 (shift ?v_1 ?ku597_555)))) (=> (and (<= 0 ?ku597_555) (< ?ku597_555 ?i0)) (= (s2int (c_sort c_int (smtlib__select ?v_5 ?v_8))) (- (s2int (c_sort c_int (smtlib__select ?v_4 ?v_8))))))))))) (and (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?i0 1)))) (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?n 1)))))) (=> (< ?i0 ?n) (forall ((?result c_unsorted)) (let ((?v_9 (pointer int_P))) (=> (= (c_sort c_int ?result) (c_sort c_int (smtlib__select ?v_5 (c_sort ?v_9 (shift ?v_1 ?i0))))) (forall ((?int_P_int_M_t_1_1 c_unsorted)) (=> (= (c_sort ?v_2 ?int_P_int_M_t_1_1) (c_sort ?v_2 (smtlib__store ?v_5 (c_sort ?v_9 (shift ?v_1 ?i0)) (c_sort c_int (int2u (- (s2int (c_sort c_int ?result)))))))) (forall ((?i1 Int)) (=> (= (c_sort c_int (int2u ?i1)) (c_sort c_int (int2u (+ ?i0 1)))) (forall ((?pu321_556 c_unsorted)) (let ((?v_10 (c_sort ?v_9 ?pu321_556))) (=> (and (and (<= (offset_min ?v_0 ?v_10) 0) (>= (offset_max ?v_0 ?v_10) 0)) (not (in_pset ?v_10 (c_sort ?v_3 (pset_range ?v_6 0 (- ?n 1)))))) (= (c_sort c_int (smtlib__select (c_sort ?v_2 ?int_P_int_M_t_1_1) ?v_10)) (c_sort c_int (smtlib__select ?v_4 ?v_10)))))))))))))))))))))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (= c_Boolean_true c_Boolean_true) (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1))))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?i0 Int)) (forall ((?int_P_int_M_t_1_0 c_unsorted)) (let ((?v_2 (memory int_P c_int)) (?v_3 (pset int_P))) (let ((?v_5 (c_sort ?v_2 ?int_P_int_M_t_1_0)) (?v_4 (c_sort ?v_2 ?int_P_int_M_t_1)) (?v_6 (c_sort ?v_3 (pset_singleton ?v_1)))) (=> (and (and (<= 0 ?i0) (and (<= ?i0 ?n) (forall ((?ku597_557 Int)) (let ((?v_7 (pointer int_P))) (let ((?v_8 (c_sort ?v_7 (shift ?v_1 ?ku597_557)))) (=> (and (<= 0 ?ku597_557) (< ?ku597_557 ?i0)) (= (s2int (c_sort c_int (smtlib__select ?v_5 ?v_8))) (- (s2int (c_sort c_int (smtlib__select ?v_4 ?v_8))))))))))) (and (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?i0 1)))) (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?n 1)))))) (=> (>= ?i0 ?n) (forall ((?ku0u598_558 Int)) (let ((?v_9 (pointer int_P))) (let ((?v_10 (c_sort ?v_9 (shift ?v_1 ?ku0u598_558)))) (=> (and (<= 0 ?ku0u598_558) (< ?ku0u598_558 ?n)) (= (s2int (c_sort c_int (smtlib__select ?v_5 ?v_10))) (- (s2int (c_sort c_int (smtlib__select ?v_4 ?v_10)))))))))))))))))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (= c_Boolean_true c_Boolean_true) (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1))))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?i0 Int)) (forall ((?int_P_int_M_t_1_0 c_unsorted)) (let ((?v_2 (memory int_P c_int)) (?v_3 (pset int_P))) (let ((?v_5 (c_sort ?v_2 ?int_P_int_M_t_1_0)) (?v_4 (c_sort ?v_2 ?int_P_int_M_t_1)) (?v_6 (c_sort ?v_3 (pset_singleton ?v_1)))) (=> (and (and (<= 0 ?i0) (and (<= ?i0 ?n) (forall ((?ku597_559 Int)) (let ((?v_7 (pointer int_P))) (let ((?v_8 (c_sort ?v_7 (shift ?v_1 ?ku597_559)))) (=> (and (<= 0 ?ku597_559) (< ?ku597_559 ?i0)) (= (s2int (c_sort c_int (smtlib__select ?v_5 ?v_8))) (- (s2int (c_sort c_int (smtlib__select ?v_4 ?v_8))))))))))) (and (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?i0 1)))) (not_assigns ?v_0 ?v_4 ?v_5 (c_sort ?v_3 (pset_range ?v_6 0 (- ?n 1)))))) (=> (>= ?i0 ?n) (forall ((?pu321_560 c_unsorted)) (let ((?v_10 (pointer int_P))) (let ((?v_9 (c_sort ?v_10 ?pu321_560))) (=> (and (and (<= (offset_min ?v_0 ?v_9) 0) (>= (offset_max ?v_0 ?v_9) 0)) (not (in_pset ?v_9 (c_sort ?v_3 (pset_range ?v_6 0 (- ?n 1)))))) (= (c_sort c_int (smtlib__select ?v_5 ?v_9)) (c_sort c_int (smtlib__select ?v_4 ?v_9)))))))))))))))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1)))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?i0 Int)) (forall ((?int_P_int_M_t_1_0 c_unsorted)) (=> true (=> (and (<= 0 ?i0) (and (<= ?i0 ?n) (forall ((?ku613_561 Int)) (let ((?v_2 (pointer int_P)) (?v_3 (memory int_P c_int))) (let ((?v_4 (c_sort ?v_2 (shift ?v_1 ?ku613_561)))) (=> (and (<= 0 ?ku613_561) (< ?ku613_561 ?i0)) (= (s2int (c_sort c_int (smtlib__select (c_sort ?v_3 ?int_P_int_M_t_1_0) ?v_4))) (- (s2int (c_sort c_int (smtlib__select (c_sort ?v_3 ?int_P_int_M_t_1) ?v_4))))))))))) (=> (< ?i0 ?n) (<= (offset_min ?v_0 ?v_1) ?i0))))))))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1)))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?i0 Int)) (forall ((?int_P_int_M_t_1_0 c_unsorted)) (=> true (=> (and (<= 0 ?i0) (and (<= ?i0 ?n) (forall ((?ku613_562 Int)) (let ((?v_2 (pointer int_P)) (?v_3 (memory int_P c_int))) (let ((?v_4 (c_sort ?v_2 (shift ?v_1 ?ku613_562)))) (=> (and (<= 0 ?ku613_562) (< ?ku613_562 ?i0)) (= (s2int (c_sort c_int (smtlib__select (c_sort ?v_3 ?int_P_int_M_t_1_0) ?v_4))) (- (s2int (c_sort c_int (smtlib__select (c_sort ?v_3 ?int_P_int_M_t_1) ?v_4))))))))))) (=> (< ?i0 ?n) (<= ?i0 (offset_max ?v_0 ?v_1)))))))))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1)))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?i0 Int)) (forall ((?int_P_int_M_t_1_0 c_unsorted)) (=> true (=> (and (<= 0 ?i0) (and (<= ?i0 ?n) (forall ((?ku613_563 Int)) (let ((?v_2 (pointer int_P)) (?v_3 (memory int_P c_int))) (let ((?v_4 (c_sort ?v_2 (shift ?v_1 ?ku613_563)))) (=> (and (<= 0 ?ku613_563) (< ?ku613_563 ?i0)) (= (s2int (c_sort c_int (smtlib__select (c_sort ?v_3 ?int_P_int_M_t_1_0) ?v_4))) (- (s2int (c_sort c_int (smtlib__select (c_sort ?v_3 ?int_P_int_M_t_1) ?v_4))))))))))) (=> (< ?i0 ?n) (=> (and (<= (offset_min ?v_0 ?v_1) ?i0) (<= ?i0 (offset_max ?v_0 ?v_1))) (forall ((?result c_unsorted)) (let ((?v_5 (pointer int_P))) (=> (= (c_sort c_int ?result) (c_sort c_int (smtlib__select (c_sort (memory int_P c_int) ?int_P_int_M_t_1_0) (c_sort ?v_5 (shift ?v_1 ?i0))))) (=> (and (<= (offset_min ?v_0 ?v_1) ?i0) (<= ?i0 (offset_max ?v_0 ?v_1))) (forall ((?int_P_int_M_t_1_1 c_unsorted)) (let ((?v_6 (memory int_P c_int))) (=> (= (c_sort ?v_6 ?int_P_int_M_t_1_1) (c_sort ?v_6 (smtlib__store (c_sort ?v_6 ?int_P_int_M_t_1_0) (c_sort ?v_5 (shift ?v_1 ?i0)) (c_sort c_int (int2u (- (s2int (c_sort c_int ?result)))))))) (forall ((?i1 Int)) (=> (= (c_sort c_int (int2u ?i1)) (c_sort c_int (int2u (+ ?i0 1)))) (<= 0 (- ?n ?i0)))))))))))))))))))))))))))
(set-info :status unsat)
(check-sat)
(assert (not (forall ((?t c_unsorted)) (forall ((?n Int)) (forall ((?int_P_t_1_alloc_table c_unsorted)) (forall ((?int_P_int_M_t_1 c_unsorted)) (let ((?v_0 (c_sort (alloc_table int_P) ?int_P_t_1_alloc_table)) (?v_1 (c_sort (pointer int_P) ?t))) (=> (and (>= ?n 0) (and (<= (offset_min ?v_0 ?v_1) 0) (>= (offset_max ?v_0 ?v_1) (- ?n 1)))) (forall ((?i Int)) (=> (= (c_sort c_int (int2u ?i)) (c_sort c_int (int2u 0))) (forall ((?i0 Int)) (forall ((?int_P_int_M_t_1_0 c_unsorted)) (=> true (=> (and (<= 0 ?i0) (and (<= ?i0 ?n) (forall ((?ku613_564 Int)) (let ((?v_2 (pointer int_P)) (?v_3 (memory int_P c_int))) (let ((?v_4 (c_sort ?v_2 (shift ?v_1 ?ku613_564)))) (=> (and (<= 0 ?ku613_564) (< ?ku613_564 ?i0)) (= (s2int (c_sort c_int (smtlib__select (c_sort ?v_3 ?int_P_int_M_t_1_0) ?v_4))) (- (s2int (c_sort c_int (smtlib__select (c_sort ?v_3 ?int_P_int_M_t_1) ?v_4))))))))))) (=> (< ?i0 ?n) (=> (and (<= (offset_min ?v_0 ?v_1) ?i0) (<= ?i0 (offset_max ?v_0 ?v_1))) (forall ((?result c_unsorted)) (let ((?v_5 (pointer int_P))) (=> (= (c_sort c_int ?result) (c_sort c_int (smtlib__select (c_sort (memory int_P c_int) ?int_P_int_M_t_1_0) (c_sort ?v_5 (shift ?v_1 ?i0))))) (=> (and (<= (offset_min ?v_0 ?v_1) ?i0) (<= ?i0 (offset_max ?v_0 ?v_1))) (forall ((?int_P_int_M_t_1_1 c_unsorted)) (let ((?v_6 (memory int_P c_int))) (=> (= (c_sort ?v_6 ?int_P_int_M_t_1_1) (c_sort ?v_6 (smtlib__store (c_sort ?v_6 ?int_P_int_M_t_1_0) (c_sort ?v_5 (shift ?v_1 ?i0)) (c_sort c_int (int2u (- (s2int (c_sort c_int ?result)))))))) (forall ((?i1 Int)) (=> (= (c_sort c_int (int2u ?i1)) (c_sort c_int (int2u (+ ?i0 1)))) (< (- ?n ?i1) (- ?n ?i0)))))))))))))))))))))))))))
(set-info :status unsat)
(check-sat)
(exit)
